/*****************************************************************************************
******************************************************************************************
Nom du fichier: DiverTWICV2.h
------------------------------------------------------------------------------------------
Auteur: Philippe MARIANO
------------------------------------------------------------------------------------------
Rle: fichier d'en-tte de la librairie DiverTWICV2.lib
------------------------------------------------------------------------------------------
Cr le : 14/11/2010
Dernire rvision le :
------------------------------------------------------------------------------------------
Cross compilateur utilis: CodeVisionAVR V2
------------------------------------------------------------------------------------------
Composants cibles : ATMEL 8 bits
------------------------------------------------------------------------------------------
Remarques:
Ce fichier est destin  un projet CVAVR utilisant la carte SSI
Il doit tre plac dans le sous rpertoire \CVAVR2\INC\ ou dans le rpertoire du projet
Placer le fichier DiverTWICV2.lib dans le rpertoire \CVAVR2\LIB\
*****************************************************************************************
*****************************************************************************************/

#ifndef _DriverTWICV2_INCLUDED_ // Evite que le fichier ne soit inclus plusieurs fois
#define _DriverTWICV2_

#pragma used+
/*****************************************************************************************************************************
        Paramtres  redfinir si ncessaire
*****************************************************************************************************************************/
#ifndef TWI_BUFFER_SIZE
#define TWI_BUFFER_SIZE             20      // Set this to the largest message size that will be sent including address byte.
#endif

#ifndef TWI_TWBR
#define TWI_TWBR                    0x20   // Pour FQ = 8MHz, Frquence de l'horloge I2C : 0x20 = 100kHz0k ; 0x02 pour 400kHz
#endif
//****************************************************************************************************************************
/*****************************************************************************************************************************
        Interrupt vectors definitions
*****************************************************************************************************************************/
#ifndef TWI
#define TWI                         18
#endif
/*****************************************************************************************************************************
        Divers
*****************************************************************************************************************************/
#ifndef TRUE
#define TRUE                        1
#endif

#ifndef FALSE
#define FALSE                       0
#endif
/*****************************************************************************************************************************
        TWI State codes
*****************************************************************************************************************************/
#ifndef TWI_NO_STATE
#define TWI_NO_STATE                0xF8  // No relevant state information available; TWINT = 0
#endif

#ifndef TWI_READ_BIT
#define TWI_READ_BIT                0    // Bit position for R/W bit in "address byte".
#endif

#ifndef TWI_ADR_BITS
#define TWI_ADR_BITS                1    // Bit position for LSB of the slave address bits in the init byte.
#endif

// General TWI Master status codes
// --------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_START
#define TWI_START                  0x08  // START has been transmitted
#endif
#ifndef TWI_REP_START
#define TWI_REP_START              0x10  // Repeated START has been transmitted
#endif
#ifndef TWI_ARB_LOST
#define TWI_ARB_LOST               0x38  // Arbitration lost
#endif

// TWI Master Transmitter status codes
// ---------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_MTX_ADR_ACK
#define TWI_MTX_ADR_ACK            0x18  // SLA+W has been tramsmitted and ACK received
#endif
#ifndef TWI_MTX_ADR_NACK
#define TWI_MTX_ADR_NACK           0x20  // SLA+W has been tramsmitted and NACK received
#endif
#ifndef TWI_MTX_DATA_ACK
#define TWI_MTX_DATA_ACK           0x28  // Data byte has been tramsmitted and ACK received
#endif
#ifndef TWI_MTX_DATA_NACK
#define TWI_MTX_DATA_NACK          0x30  // Data byte has been tramsmitted and NACK received
#endif

// TWI Master Receiver status codes
// --------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_MRX_ADR_ACK
#define TWI_MRX_ADR_ACK            0x40  // SLA+R has been tramsmitted and ACK received
#endif
#ifndef TWI_MRX_ADR_NACK
#define TWI_MRX_ADR_NACK           0x48  // SLA+R has been tramsmitted and NACK received
#endif
#ifndef TWI_MRX_DATA_ACK
#define TWI_MRX_DATA_ACK           0x50  // Data byte has been received and ACK tramsmitted
#endif
#ifndef TWI_MRX_DATA_NACK
#define TWI_MRX_DATA_NACK          0x58  // Data byte has been received and NACK tramsmitted
#endif

// TWI Slave Transmitter status codes
// --------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_STX_ADR_ACK
#define TWI_STX_ADR_ACK            0xA8  // Own SLA+R has been received; ACK has been returned
#endif
#ifndef TWI_STX_ADR_ACK_M_ARB_LOST
#define TWI_STX_ADR_ACK_M_ARB_LOST 0xB0  // Arbitration lost in SLA+R/W as Master; own SLA+R has been received; 
#endif                                   // ACK has been returned
#ifndef TWI_STX_ADR_ACK_M_ARB_LOST
#define TWI_STX_DATA_ACK           0xB8  // Data byte in TWDR has been transmitted; ACK has been received
#endif
#ifndef TWI_STX_DATA_NACK
#define TWI_STX_DATA_NACK          0xC0  // Data byte in TWDR has been transmitted; NOT ACK has been received
#endif
#ifndef TWI_STX_DATA_ACK_LAST_BYTE
#define TWI_STX_DATA_ACK_LAST_BYTE 0xC8  // Last data byte in TWDR has been transmitted (TWEA = 0); ACK has been received
#endif

// TWI Slave Receiver status codes
// --------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_SRX_ADR_ACK
#define TWI_SRX_ADR_ACK            0x60  // Own SLA+W has been received ACK has been returned
#endif
#ifndef TWI_SRX_ADR_ACK_M_ARB_LOST
#define TWI_SRX_ADR_ACK_M_ARB_LOST 0x68  // Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been 
#endif                                   // returned
#ifndef TWI_SRX_GEN_ACK
#define TWI_SRX_GEN_ACK            0x70  // General call address has been received; ACK has been returned
#endif
#ifndef TWI_SRX_GEN_ACK_M_ARB_LOST
#define TWI_SRX_GEN_ACK_M_ARB_LOST 0x78  // Arbitration lost in SLA+R/W as Master; General call address has been received; 
#endif                                   // ACK has been returned
#ifndef TWI_SRX_ADR_DATA_ACK
#define TWI_SRX_ADR_DATA_ACK       0x80  // Previously addressed with own SLA+W; data has been received; 
#endif                                   // ACK has been returned
#ifndef TWI_SRX_ADR_DATA_NACK
#define TWI_SRX_ADR_DATA_NACK      0x88  // Previously addressed with own SLA+W; data has been received; 
#endif                                   // NOT ACK has been returned
#ifndef TWI_SRX_GEN_DATA_ACK
#define TWI_SRX_GEN_DATA_ACK       0x90  // Previously addressed with general call; data has been received; 
#endif                                   // ACK has been returned
#ifndef TWI_SRX_GEN_DATA_NACK
#define TWI_SRX_GEN_DATA_NACK      0x98  // Previously addressed with general call; data has been received; 
#endif                                   // NOT ACK has been returned
#ifndef TWI_SRX_STOP_RESTART
#define TWI_SRX_STOP_RESTART       0xA0  // A STOP condition or repeated START condition has been received while still 
#endif                                   // addressed as Slave

// TWI Miscellaneous status codes
// --------------------------------------------------------------------------------------------------------------------------
#ifndef TWI_BUS_ERROR
#define TWI_BUS_ERROR              0x00  // Bus error due to an illegal START or STOP condition
#endif


/****************************************************************************************************************************
        Description of functions in the TWI Master driver
****************************************************************************************************************************/
// --------------------------------------------------------------------------------------------------------------------------
void TWI_Master_Initialise(void);
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to set up the TWI master to its initial standby state.
Remember to enable interrupts from the main application after initializing the TWI.
---------------------------------------------------------------------------------------------------------------------------*/
// --------------------------------------------------------------------------------------------------------------------------
unsigned char TWI_Transceiver_Busy(void);
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to test if the TWI_ISR is busy transmitting.
---------------------------------------------------------------------------------------------------------------------------*/
unsigned char TWI_Get_State_Info( void );
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to fetch the state information of the previous operation. The function will hold execution 
(loop) until the TWI_ISR has completed with the previous operation. If there was an error, then the function will return the 
TWI State code.
---------------------------------------------------------------------------------------------------------------------------*/
// --------------------------------------------------------------------------------------------------------------------------
void TWI_Start_Transc_With_Data( unsigned char *message, unsigned char messageSize );
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to send a prepared message. The first byte must contain the slave address and the 
read/write bit. Consecutive bytes contain the data to be sent, or empty locations for data to be read from the slave. Also 
include how many bytes that should be sent/read including the address byte. The function will hold execution (loop) until 
the TWI_ISR has completed with the previous operation, then initialize the next operation and return.
---------------------------------------------------------------------------------------------------------------------------*/
void TWI_Start_Transceiver( void );
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to resend the last message. The driver will reuse the data previously put in the 
transceiver buffers. The function will hold execution (loop) until the TWI_ISR has completed with the previous operation, 
then initialize the next operation and return.
---------------------------------------------------------------------------------------------------------------------------*/
// --------------------------------------------------------------------------------------------------------------------------
unsigned char TWI_Get_Data_From_Transceiver( unsigned char *message, unsigned char messageSize );
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : Call this function to read out the requested data from the TWI transceiver buffer.
I.e. first call TWI_Start_Transceiver to send a request for data to the slave.
Then Run this function to collect the data when they have arrived. Include a pointer to where
to place the data and the number of bytes requested (including the address field) in the function call. The function will hold
execution (loop) until the TWI_ISR has completed with the previous operation, before reading out the data and returning.
If there was an error in the previous transmission the function will return the TWI error code.
---------------------------------------------------------------------------------------------------------------------------*/
// --------------------------------------------------------------------------------------------------------------------------
interrupt [TWI] void twi_isr(void);
/* --------------------------------------------------------------------------------------------------------------------------
Commentaires : This function is the Interrupt Service Routine (ISR), and automatically called when the TWI interrupt is 
triggered; that is whenever a TWI event has occurred. This function should be called directly from the main application.
----------------------------------------------------------------------------------------------------------------------------*/
// --------------------------------------------------------------------------------------------------------------------------

#pragma used-

#pragma library DriverTWICV2.lib

#endif    // termine la directive ifndef