
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float ftrunc(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

void TWI_Master_Initialise(void);

unsigned char TWI_Transceiver_Busy(void);

unsigned char TWI_Get_State_Info( void );

void TWI_Start_Transc_With_Data( unsigned char *message, unsigned char messageSize );

void TWI_Start_Transceiver( void );

unsigned char TWI_Get_Data_From_Transceiver( unsigned char *message, unsigned char messageSize );

interrupt [20] void twi_isr(void);

#pragma used-

#pragma library DriverTWICV2.lib

#pragma used+

unsigned char LSBYTE(int value);

unsigned char MSBYTE(int value);

unsigned int MSLSBYTEtoUINT(unsigned char MSB, unsigned char LSB);

#pragma used-

#pragma library Stdmno.lib

#pragma used+

void Init_LCD_I2C_BATRON(void);

void LCD_I2C_BATRON_gotoxy(unsigned char x, unsigned char y);

void Built_Strng_Fram_I2C_LCDBATRON(unsigned char *FrameI2C, unsigned char *Tstring, int Tstringsize);

void Displ_2Lines_On_I2C_LCDBATRON(unsigned char *Buffer_for_LCD_Line0, unsigned char *Buffer_for_LCD_Line1);

void Display_Arrow_0n_I2C_LCDBATRON(void);

#pragma used-

#pragma library LCDBATRON.lib

unsigned char Lire_BP_I2C(void);

#pragma used-

#pragma library SISISOL.lib

flash unsigned char Tab_Servo[]={
0		, 	
3		, 	
6		, 
9		 

};  

flash unsigned int Tab_Position[]={
800, 	
1000,	
1500,
2000

};

flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";
flash char *Texte_Accueil_Ligne2 	= "[RBSOL 25/05/11]";
flash char *TexteMenuLedBp			= "[1]Test BP->Led ";
flash char *TexteMenuMD23			= "[2]Test MD23    ";
flash char *TexteMenuSD21			= "[3]Test SD21    ";
flash char *TexteMenuHMC6352        = "[4]HMC6352      ";
flash char *Ligne0MenuMode			= "[20]Choix Modes ";
flash char *Ligne0MenuInfos			= "[21]Aff Infos   ";
flash char *Ligne0MenuDeplacements  = "[22]Choix Depl. ";
flash char *TexteTestSD21           = "Cde Servo 1->4  ";
flash char *TexteTest1BpsurLed	    = "Recopie Bp->Led ";
flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
flash char *Ligne1ChoixEntr			= "[Entr]          ";
flash char *Ligne1ChoixEchap		= "        [Echap] ";
flash char *Ligne1ChoixEchap5s		= "    [Echap 5s!] ";
flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
flash char *Ligne1ChoixEchapSET		= "[SET]   [Echap] ";
flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
flash char *BpSetSurD4				= "SET->D4 [Echap] ";
flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
flash char *BpEchSurD7				= "ECH->D7 [Echap] ";

enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Menu4_HMC6352, Menu20_Mode_MD23, Menu21_Infos_MD23, Menu22_Deplacements, 
Copie_BP_Sur_Led, Choix_Mode_MD23, Reglage_Valeurs_Mode0_MD23, Info_All, Info_Version,  Info_TensionBatt, 
Selection_Deplacements, Test_Deplacements_Elementaires, Balayage, Orientation_Sud, Test_HMC6352, Test_SD21} 
Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;

bit Choix_Moteur=0;			

void main(void)
{

char Frame_I2C_LED_All_Off[]={0x40    ,0xff}; 		
char Frame_I2C_LED_Switching[]={0x40    ,0x00}; 	

char Frame_I2C_BP_Read[]={0x43  	,0x00}; 			

char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	        

unsigned char Reset_Encodeurs_MD23[]={0xB0    ,16	    , 32}; 

unsigned char Mode0_MD23[]={0xB0    ,15	    ,0	    };    

unsigned char Speed1[]={0xB0    ,0  	    , 128};		
unsigned char Speed2[]={0xB0    ,1	    , 128};  
unsigned char Time_OUT_Desable[]={0xB0    ,16	    , 50}; 

unsigned char Read_Reg_MD23_W[]= {0xB0    ,0};		    

unsigned char Frame_I2C_Servo[]={0xC2    ,0		,0,0xE8,0x03};		 

unsigned char Frame_I2C_Write_Command_HMC6352[] = {0x44 ,'A'};      
unsigned char Frame_I2C_Read_Data_HMC6352[] = {0x45 ,0,0};    

unsigned int Num_Reg_MD23_1 = 0;
unsigned char Vitesse_MD23_1 = 1,  BP_I2C_1 = 1, Finesse_1 = 1;
unsigned char SpeedMot1_1 = 128, SpeedMot2_1 = 128;
signed char Choix_Mode_1 = 1;
unsigned char Ubatt_1=0;
unsigned char Version_1=0;
long int TableCodeur_1[2] = {0,0};
unsigned char SelecDeplacement_1 = 0;

unsigned int Num_Reg_MD23 = 0;                        		        
unsigned char Vitesse_MD23 = 0, BP_I2C = 0,  Finesse = 5 ;
unsigned char SpeedMot1 = 128, SpeedMot2 = 128 ;        
signed char Choix_Mode = 0;
unsigned char Ubatt = 0;				                
unsigned char Version = 0;                              
long int TableCodeur[2] = {0,0};                        

long int Valeur_Codeur_Stop = 0;                        
unsigned char NumeroCodeur = 0; 

unsigned char SelecDeplacement = 0;                     

unsigned int Table_Balayage[16             ][4] = 
{  
{151,151,5137,0},    
{171,130,1768,0},    
{151,151,4584,0},    
{130,171,1768,1},    
{151,151,4584,0},    
{171,130,1768,0},    
{151,151,4584,0},    
{130,171,1768,1},    
{151,151,4584,0},    
{171,130,1768,0},    
{151,151,4584,0},    
{130,171,1768,1},    
{151,151,4584,0},    
{171,130,1768,0},    
{151,151,5137,0},    
{128,128,100,0}      
}; 

char AfficheDeplacement1[11];         
char AfficheDeplacement2[11];         

unsigned char Table_Registers_MD23[]={0xB1    ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];        

unsigned char Vitesse = 5;				    
unsigned int tempo = 1000;                  
unsigned int i = 0;						    

unsigned char Direction_MSB_1 = 0, Direction_LSB_1 = 0;

unsigned char Direction_MSB = 0,  Direction_LSB = 0;    
unsigned int AngleEnDegreFoisDix=0;                     

char AfficheAngle[] = {"0000"};                         

TWI_Master_Initialise(); 									    

#asm("sei")					    

TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); 

Init_LCD_I2C_BATRON();

TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));

TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));

sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
delay_ms(4000);

while (1)
{

TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);          

TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));

BP_I2C = Lire_BP_I2C();

if (Menu != Reglage_Valeurs_Mode0_MD23)
{                                                         
TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		
TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
}

switch(Menu)
{

case Menu1_LED_BP : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Copie_BP_Sur_Led;  break;     
case 2: Menu = Menu4_HMC6352;  break;     
case 4: Menu = Menu2_MD23;  break;        
default: Menu = Menu1_LED_BP;
}
Menu_1 = Menu1_LED_BP;
break;

case Menu2_MD23 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Menu20_Mode_MD23;  break;     
case 2: Menu = Menu1_LED_BP;  break;      
case 4: Menu = Menu3_SD21;  break;        
default: Menu = Menu2_MD23 ;
}
Menu_1 = Menu2_MD23 ;
break;

case Menu3_SD21 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Test_SD21;  break;           
case 2: Menu = Menu2_MD23;  break;       
case 4: Menu = Menu4_HMC6352;  break;    
default: Menu = Menu3_SD21 ;
}
Menu_1 = Menu3_SD21 ;            
break; 

case Menu4_HMC6352 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteMenuHMC6352);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}
switch (BP_I2C)
{
case 64: Menu = Test_HMC6352;  break;         
case 2: Menu = Menu3_SD21;  break;        
case 4: Menu = Menu1_LED_BP;  break;      
default: Menu = Menu4_HMC6352 ;
}
Menu_1 = Menu4_HMC6352 ;            
break;

case Menu20_Mode_MD23 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
LCD_I2C_BATRON_gotoxy(0,15);
Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0));
TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
Display_Arrow_0n_I2C_LCDBATRON();
}

switch (BP_I2C)
{
case 64: Menu = Choix_Mode_MD23;  break;         
case 2: Menu = Menu22_Deplacements;  break;  
case 4: Menu = Menu21_Infos_MD23;  break;    
case 128 : Menu = Menu2_MD23; break;             
default: Menu = Menu20_Mode_MD23 ;
}
Menu_1 = Menu20_Mode_MD23;
break;

case Menu21_Infos_MD23: if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}

switch (BP_I2C)
{
case 64: Menu = Info_All;  break;
case 2: Menu = Menu20_Mode_MD23;  break;
case 4: Menu = Menu22_Deplacements;  break;
case 128 : Menu = Menu2_MD23; break; 
default: Menu = Menu21_Infos_MD23 ;
}

Menu_1 = Menu21_Infos_MD23 ;
break;

case Menu22_Deplacements: if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,Ligne0MenuDeplacements);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
}

switch (BP_I2C)
{
case 64: Menu = Selection_Deplacements;  break;
case 2: Menu = Menu21_Infos_MD23;  break;
case 4: Menu = Menu20_Mode_MD23;  break;
case 128 : Menu = Menu2_MD23; break;              
default: Menu = Menu22_Deplacements ;
}
Menu_1 = Menu22_Deplacements ;
break;

case Copie_BP_Sur_Led : 
if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
{
sprintf(Buffer_for_LCD_Line0,TexteTest1BpsurLed);

switch (BP_I2C)
{
case 64 : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
case 2 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
case 4 : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
case 128 : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
case 32 : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
case 8: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
case 1: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
case 16: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
}

Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
BP_I2C_1 = BP_I2C;
}

if (BP_I2C == 128)
{
Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	
delay_ms(1000);
Menu = Menu1_LED_BP;
}
else  Menu = Copie_BP_Sur_Led;

Menu_1 = Copie_BP_Sur_Led;
break;

case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
{
sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Choix_Mode_1 = Choix_Mode;
}

switch (BP_I2C)
{
case 128 : Menu=Menu20_Mode_MD23; break;  
case 2: Choix_Mode = Choix_Mode - 1; if (Choix_Mode < 0) Choix_Mode=3;  break; 
case 4:  Choix_Mode = Choix_Mode + 1; if (Choix_Mode > 3) Choix_Mode=0 ;  break; 
case 64: if (Choix_Mode == 0) 
{SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Valeurs_Mode0_MD23;}	
break;

default: Menu=Choix_Mode_MD23;
}

Menu_1 = Choix_Mode_MD23;
break;

case Reglage_Valeurs_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)
||(Finesse_1 != Finesse))
{
sprintf(Buffer_for_LCD_Line0,"[200]Mode%-u (+%-u) ",Choix_Mode,Finesse);
sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
}

switch (BP_I2C)
{
case 128 :  Menu=Choix_Mode_MD23; break;

case 1:
switch (Choix_Moteur)
{
case 0: if (Finesse==1)
if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
else 
if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
break;
case 1: if (Finesse==1)
if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
else 
if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
break;
}
break;

case 8:
switch (Choix_Moteur)
{
case 0: if (Finesse==1)
if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
else  
if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0;
break;
case 1: if (Finesse==1)
if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
else  
if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
break;
}
break;

case 2: if (Finesse==1) Finesse = 5; else Finesse = 1; break;

case 4: if (Finesse==1) Finesse = 5; else Finesse = 1; break;

case 32: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; break;

case 16:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2;
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
break;

default: Menu = Reglage_Valeurs_Mode0_MD23;
}
Menu_1 = Reglage_Valeurs_Mode0_MD23;
break;

case Info_All: Vitesse_MD23 = Table_Registers_MD23[6]; 
if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23))
{
sprintf(Buffer_for_LCD_Line0,"[210] Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;
strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
}

switch (BP_I2C)
{
case 128 : Menu=Menu21_Infos_MD23; break;
case 1: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break;
case 8: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break;
case 2: Menu = Info_TensionBatt;  break;
case 4: Menu = Info_Version;  break;
default: Menu=Info_All;
}

Menu_1 = Info_All;
break;

case Info_Version:	Version = Table_Registers_MD23[14];
if ((Menu_1 != Menu)||(Version_1 != Version))
{
sprintf(Buffer_for_LCD_Line0,"[211] Vers.=%-u  ",Version);
strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Version_1 = Version;
}

switch (BP_I2C)
{
case 128 : Menu=Menu21_Infos_MD23; break;
case 2: Menu = Info_All;  break;
case 4: Menu = Info_TensionBatt;  break;
default: Menu=Info_Version;
}

Menu_1 = Info_Version;
break;

case Info_TensionBatt:  	Ubatt = Table_Registers_MD23[11];
if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt))
{
sprintf(Buffer_for_LCD_Line0,"[212]Ubat=%-u.%-uV ",Ubatt/10, Ubatt-10*(Ubatt/10));
strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
Ubatt_1 = Ubatt;
}

switch (BP_I2C)
{
case 128 : Menu=Menu21_Infos_MD23; break;
case 2: Menu = Info_Version;  break;
case 4: Menu = Info_All;  break;
default: Menu=Info_TensionBatt;
}

Menu_1 = Info_TensionBatt;
break;

case Selection_Deplacements:  	
if ((Menu_1 != Menu)||(SelecDeplacement_1 != SelecDeplacement))
{
switch (SelecDeplacement)
{
case 0: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droit "); break;
case 1: sprintf(Buffer_for_LCD_Line0,"[221]Virage G90 "); break;
case 2: sprintf(Buffer_for_LCD_Line0,"[222]Vira. G180 "); break;
case 3: sprintf(Buffer_for_LCD_Line0,"[223]Virage D90 "); break;
case 4: sprintf(Buffer_for_LCD_Line0,"[224]Vira. D180 "); break;
case 5: sprintf(Buffer_for_LCD_Line0,"[225]Bala. Zone "); break;
case 6: sprintf(Buffer_for_LCD_Line0,"[226]Orien. Sud "); break;
default: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droit ");
}
strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchapSET);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
Display_Arrow_0n_I2C_LCDBATRON();
SelecDeplacement_1 = SelecDeplacement;
}

switch (BP_I2C)
{
case 128 : Menu = Menu22_Deplacements; break;
case 2: if (SelecDeplacement > 0) SelecDeplacement--; else SelecDeplacement=6;  break;
case 4: if (SelecDeplacement < 6) SelecDeplacement++; else SelecDeplacement=0;  break;
case 16:   
switch (SelecDeplacement) 
{ 

case 0: Speed1[2] = 151; Speed2[2] = 151; Valeur_Codeur_Stop = 1156; NumeroCodeur = 0;  break;  
case 1: Speed1[2] = 128; Speed2[2] = 173; Valeur_Codeur_Stop = 828; NumeroCodeur = 1; break;    
case 2: Speed1[2] = 128; Speed2[2] = 173; Valeur_Codeur_Stop = 1656; NumeroCodeur = 1; break;   
case 3: Speed1[2] = 173; Speed2[2] = 128; Valeur_Codeur_Stop = 828; NumeroCodeur = 0; break;    
case 4: Speed1[2] = 173; Speed2[2] = 128; Valeur_Codeur_Stop = 1656; NumeroCodeur = 0; break;   
case 5: 

Direction_MSB = 0; Direction_LSB = 0; AngleEnDegreFoisDix = 0;
i = 0; 
delay_ms(3000); 

TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
Speed1[2] = Table_Balayage[i][0]; Speed2[2] = Table_Balayage[i][1];
Valeur_Codeur_Stop = Table_Balayage[i][2]; NumeroCodeur = Table_Balayage[i][3]; 
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
Menu = Balayage;
break;
case 6:    delay_ms(3000); Menu = Orientation_Sud; break;
default :  Speed1[2] = 128; Speed2[2] = 128;           
}

if (SelecDeplacement < 5)
{ 
delay_ms(3000); 

TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
Menu = Test_Deplacements_Elementaires;
}  

break;
default: Menu = Selection_Deplacements;
}

Menu_1 = Selection_Deplacements;
break;

case Test_Deplacements_Elementaires:

TableCodeur[0] = (long int)65536*Table_Registers_MD23[4] + (long int)256*Table_Registers_MD23[5] + Table_Registers_MD23[6];
TableCodeur[1] = (long int)65536*Table_Registers_MD23[8] + (long int)256*Table_Registers_MD23[9] + Table_Registers_MD23[10];

if (TableCodeur[NumeroCodeur] >= Valeur_Codeur_Stop)                                                                        
{                                                                  
Speed1[2] = 128; Speed2[2] = 128;  
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
} 

else  if ((Menu_1 != Menu) || (TableCodeur_1[NumeroCodeur] != TableCodeur[NumeroCodeur]))	                                                                  

{ 
ltoa(TableCodeur[0], AfficheDeplacement1); 
ltoa(TableCodeur[1], AfficheDeplacement2); 
strcpy(Buffer_for_LCD_Line0,"Enc1=");                       
strcat(Buffer_for_LCD_Line0, AfficheDeplacement1);
strcpyf(Buffer_for_LCD_Line1,"Enc2=");
strcat(Buffer_for_LCD_Line1, AfficheDeplacement2);
strcat(Buffer_for_LCD_Line1," [Echa]");
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
TableCodeur_1[NumeroCodeur] = TableCodeur[NumeroCodeur];
}

switch (BP_I2C)
{
case 128 : Menu = Selection_Deplacements;
Speed1[2] = 128; Speed2[2] = 128;   
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
delay_ms(500); 

TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23)); 
break;
default: Menu = Test_Deplacements_Elementaires;
}

Menu_1 = Test_Deplacements_Elementaires;
break;

case Balayage: 

for (i = 0 ; i <  16              - 1;i++)
{
do
{

TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		
TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));

TableCodeur[0] = (long int)65536*Table_Registers_MD23[4] + (long int)256*Table_Registers_MD23[5] + Table_Registers_MD23[6];
TableCodeur[1] = (long int)65536*Table_Registers_MD23[8] + (long int)256*Table_Registers_MD23[9] + Table_Registers_MD23[10]; 

ltoa(TableCodeur[0], AfficheDeplacement1);                      
ltoa(TableCodeur[1], AfficheDeplacement2);                      
strcpy(Buffer_for_LCD_Line0,"Enc1=");                       
strcat(Buffer_for_LCD_Line0, AfficheDeplacement1);
strcpyf(Buffer_for_LCD_Line1,"Enc2=");
strcat(Buffer_for_LCD_Line1, AfficheDeplacement2);
strcat(Buffer_for_LCD_Line1," [Echa]");
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
TableCodeur_1[NumeroCodeur] = TableCodeur[NumeroCodeur];
} 
while (TableCodeur[NumeroCodeur] <= Valeur_Codeur_Stop);        

Speed1[2] = Table_Balayage[i+1][0]; Speed2[2] = Table_Balayage[i+1][1]; 
Valeur_Codeur_Stop = Table_Balayage[i+1][2]; NumeroCodeur = Table_Balayage[i+1][3];                            
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));    
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23)); 
delay_ms(500); 
} 

delay_ms(3000);
Menu = Orientation_Sud;

Menu_1 = Balayage;
break;

case Orientation_Sud:  

TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352)); 
delay_ms(10); 

TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352)); 
Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];

AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);

if (AngleEnDegreFoisDix > 1800)
{
Speed1[2] = 139; Speed2[2] = 117;  
}
else
{ 
Speed1[2] = 117; Speed2[2] = 139; 
}
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));

do
{

itoa(AngleEnDegreFoisDix,AfficheAngle); 
if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
{	
sprintf(Buffer_for_LCD_Line0,"MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,AfficheAngle); 
Display_Arrow_0n_I2C_LCDBATRON();
Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB; 
} 

TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352));
delay_ms(10); 

TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352)); 
Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];

AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);    

TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2)); 
}
while (( AngleEnDegreFoisDix < 3550) && ( AngleEnDegreFoisDix > 50));

Speed1[2] = 128; Speed2[2] = 128;                          
TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
delay_ms(1000); 
Menu = Test_HMC6352;  

Menu_1 = Orientation_Sud ;
break;

case Test_HMC6352 : 

TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352));
delay_ms(10); 

TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352)); 
Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];

Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1]; 

AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);
itoa(AngleEnDegreFoisDix,AfficheAngle);

if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB)) 
{	
sprintf(Buffer_for_LCD_Line0,"MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,AfficheAngle); 
Display_Arrow_0n_I2C_LCDBATRON();
Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB; 
}  

delay_ms(100); 

switch (BP_I2C)
{
case 128: Menu = Menu4_HMC6352;  break;       
case 2: Menu = Menu3_SD21;  break;        
case 4: Menu = Menu1_LED_BP;  break;      
default: Menu = Test_HMC6352; ;
}

Menu_1 = Test_HMC6352; ;           
break;

case Test_SD21 : if (Menu_1 != Menu)
{
sprintf(Buffer_for_LCD_Line0,TexteTestSD21);
sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap5s);
Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
}  

Frame_I2C_Servo[2]  = Vitesse; Frame_I2C_Servo[3] = 0xE8; Frame_I2C_Servo[4]=0x03;  					
TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			

while (BP_I2C != 128) 
{ 

for(i=0; i<sizeof(Tab_Servo); i++)
{

Frame_I2C_Servo[1] = Tab_Servo[i]; Frame_I2C_Servo[3]  = LSBYTE(Tab_Position[i]);  Frame_I2C_Servo[4] = MSBYTE(Tab_Position[i]); 

TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));	      

Frame_I2C_LED_Switching[1] = ~(i+1);
TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
delay_ms(tempo);   
} 

BP_I2C = Lire_BP_I2C();    
} 

Frame_I2C_Servo[2]  = 0; TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));

Menu = Menu3_SD21 ; Menu_1 = Test_SD21 ;

break; 

}

Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1]; 

TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  

}; 

} 

