
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Texte_Accueil_Ligne1=R4
	.DEF _Texte_Accueil_Ligne2=R6
	.DEF _TexteMenuLedBp=R8
	.DEF _TexteMenuMD23=R10
	.DEF _TexteMenuSD21=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _twi_isr
	JMP  0x00

_Tab_Servo:
	.DB  0x0,0x3,0x6,0x9
_Tab_Position:
	.DB  0x20,0x3,0xE8,0x3,0xDC,0x5,0xD0,0x7
_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  LOW(_0x0*2+85),HIGH(_0x0*2+85)
_0x4:
	.DB  LOW(_0x0*2+102),HIGH(_0x0*2+102)
_0x5:
	.DB  LOW(_0x0*2+119),HIGH(_0x0*2+119)
_0x6:
	.DB  LOW(_0x0*2+136),HIGH(_0x0*2+136)
_0x7:
	.DB  LOW(_0x0*2+153),HIGH(_0x0*2+153)
_0x8:
	.DB  LOW(_0x0*2+170),HIGH(_0x0*2+170)
_0x9:
	.DB  LOW(_0x0*2+187),HIGH(_0x0*2+187)
_0xA:
	.DB  LOW(_0x0*2+204),HIGH(_0x0*2+204)
_0xB:
	.DB  LOW(_0x0*2+221),HIGH(_0x0*2+221)
_0xC:
	.DB  LOW(_0x0*2+238),HIGH(_0x0*2+238)
_0xD:
	.DB  LOW(_0x0*2+255),HIGH(_0x0*2+255)
_0xE:
	.DB  LOW(_0x0*2+272),HIGH(_0x0*2+272)
_0xF:
	.DB  LOW(_0x0*2+289),HIGH(_0x0*2+289)
_0x10:
	.DB  LOW(_0x0*2+306),HIGH(_0x0*2+306)
_0x11:
	.DB  LOW(_0x0*2+323),HIGH(_0x0*2+323)
_0x12:
	.DB  LOW(_0x0*2+340),HIGH(_0x0*2+340)
_0x13:
	.DB  LOW(_0x0*2+357),HIGH(_0x0*2+357)
_0x14:
	.DB  LOW(_0x0*2+374),HIGH(_0x0*2+374)
_0x15:
	.DB  LOW(_0x0*2+391),HIGH(_0x0*2+391)
_0x16:
	.DB  LOW(_0x0*2+408),HIGH(_0x0*2+408)
_0x17:
	.DB  0x1
_0x18:
	.DB  0x30,0x30,0x30,0x30,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0xE8,0x3,0x5
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0xB1,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x97,0x0,0x97,0x0,0x11,0x14
	.DB  0x0,0x0,0xAB,0x0,0x82,0x0,0xE8,0x6
	.DB  0x0,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0x82,0x0,0xAB,0x0,0xE8,0x6
	.DB  0x1,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0xAB,0x0,0x82,0x0,0xE8,0x6
	.DB  0x0,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0x82,0x0,0xAB,0x0,0xE8,0x6
	.DB  0x1,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0xAB,0x0,0x82,0x0,0xE8,0x6
	.DB  0x0,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0x82,0x0,0xAB,0x0,0xE8,0x6
	.DB  0x1,0x0,0x97,0x0,0x97,0x0,0xE8,0x11
	.DB  0x0,0x0,0xAB,0x0,0x82,0x0,0xE8,0x6
	.DB  0x0,0x0,0x97,0x0,0x97,0x0,0x11,0x14
	.DB  0x0,0x0,0x80,0x0,0x80,0x0,0x64,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x80,0x80,0x5,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x1,0x80,0x45
	.DB  0x0,0x0,0x44,0x41,0xC2,0x0,0x0,0xE8
	.DB  0x3,0xB0,0x0,0xB0,0x10,0x32,0xB0,0x1
	.DB  0x80,0xB0,0x0,0x80,0xB0,0xF,0x0,0xB0
	.DB  0x10,0x20,0x76,0x40,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x43,0x0,0x40
	.DB  0x0,0x40,0xFF
_0x157:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+17),HIGH(_0x0*2+17),LOW(_0x0*2+34),HIGH(_0x0*2+34),LOW(_0x0*2+51),HIGH(_0x0*2+51)
	.DB  LOW(_0x0*2+68),HIGH(_0x0*2+68)
_0x0:
	.DB  0x20,0x20,0x20,0x54,0x65,0x73,0x74,0x20
	.DB  0x53,0x49,0x53,0x49,0x20,0x20,0x20,0x20
	.DB  0x0,0x5B,0x52,0x42,0x53,0x4F,0x4C,0x20
	.DB  0x32,0x35,0x2F,0x30,0x35,0x2F,0x31,0x31
	.DB  0x5D,0x0,0x5B,0x31,0x5D,0x54,0x65,0x73
	.DB  0x74,0x20,0x42,0x50,0x2D,0x3E,0x4C,0x65
	.DB  0x64,0x20,0x0,0x5B,0x32,0x5D,0x54,0x65
	.DB  0x73,0x74,0x20,0x4D,0x44,0x32,0x33,0x20
	.DB  0x20,0x20,0x20,0x0,0x5B,0x33,0x5D,0x54
	.DB  0x65,0x73,0x74,0x20,0x53,0x44,0x32,0x31
	.DB  0x20,0x20,0x20,0x20,0x0,0x5B,0x34,0x5D
	.DB  0x48,0x4D,0x43,0x36,0x33,0x35,0x32,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x5B,0x32
	.DB  0x30,0x5D,0x43,0x68,0x6F,0x69,0x78,0x20
	.DB  0x4D,0x6F,0x64,0x65,0x73,0x20,0x0,0x5B
	.DB  0x32,0x31,0x5D,0x41,0x66,0x66,0x20,0x49
	.DB  0x6E,0x66,0x6F,0x73,0x20,0x20,0x20,0x0
	.DB  0x5B,0x32,0x32,0x5D,0x43,0x68,0x6F,0x69
	.DB  0x78,0x20,0x44,0x65,0x70,0x6C,0x2E,0x20
	.DB  0x0,0x43,0x64,0x65,0x20,0x53,0x65,0x72
	.DB  0x76,0x6F,0x20,0x31,0x2D,0x3E,0x34,0x20
	.DB  0x20,0x0,0x52,0x65,0x63,0x6F,0x70,0x69
	.DB  0x65,0x20,0x42,0x70,0x2D,0x3E,0x4C,0x65
	.DB  0x64,0x20,0x0,0x5B,0x2B,0x2F,0x2D,0x5D
	.DB  0x20,0x20,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x5B,0x45,0x6E,0x74
	.DB  0x72,0x5D,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x70,0x5D,0x20,0x0,0x20,0x20
	.DB  0x20,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x20,0x35,0x73,0x21,0x5D,0x20,0x0,0x5B
	.DB  0x45,0x6E,0x74,0x72,0x5D,0x20,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x5B,0x53,0x45,0x54,0x5D,0x20,0x20,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x2B,0x20,0x2D,0x3E,0x20,0x44,0x30
	.DB  0x20,0x5B,0x45,0x63,0x68,0x61,0x70,0x5D
	.DB  0x20,0x0,0x46,0x48,0x2D,0x3E,0x20,0x44
	.DB  0x31,0x20,0x5B,0x45,0x63,0x68,0x61,0x70
	.DB  0x5D,0x20,0x0,0x46,0x42,0x2D,0x3E,0x20
	.DB  0x44,0x32,0x20,0x5B,0x45,0x63,0x68,0x61
	.DB  0x70,0x5D,0x20,0x0,0x2D,0x20,0x2D,0x3E
	.DB  0x20,0x44,0x33,0x20,0x5B,0x45,0x63,0x68
	.DB  0x61,0x70,0x5D,0x20,0x0,0x53,0x45,0x54
	.DB  0x2D,0x3E,0x44,0x34,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x70,0x5D,0x20,0x0,0x4F,0x6B
	.DB  0x2D,0x3E,0x20,0x44,0x35,0x20,0x5B,0x45
	.DB  0x63,0x68,0x61,0x70,0x5D,0x20,0x0,0x45
	.DB  0x4E,0x54,0x2D,0x3E,0x44,0x36,0x20,0x5B
	.DB  0x45,0x63,0x68,0x61,0x70,0x5D,0x20,0x0
	.DB  0x45,0x43,0x48,0x2D,0x3E,0x44,0x37,0x20
	.DB  0x5B,0x45,0x63,0x68,0x61,0x70,0x5D,0x20
	.DB  0x0,0x43,0x68,0x6F,0x69,0x78,0x3A,0x20
	.DB  0x4D,0x6F,0x64,0x65,0x25,0x2D,0x75,0x20
	.DB  0x20,0x20,0x20,0x0,0x5B,0x32,0x30,0x30
	.DB  0x5D,0x4D,0x6F,0x64,0x65,0x25,0x2D,0x75
	.DB  0x20,0x28,0x2B,0x25,0x2D,0x75,0x29,0x20
	.DB  0x0,0x53,0x4D,0x31,0x3D,0x25,0x2D,0x75
	.DB  0x20,0x53,0x4D,0x32,0x3D,0x25,0x2D,0x75
	.DB  0x0,0x5B,0x32,0x31,0x30,0x5D,0x20,0x52
	.DB  0x65,0x67,0x25,0x2D,0x75,0x3D,0x20,0x25
	.DB  0x2D,0x75,0x0,0x5B,0x32,0x31,0x31,0x5D
	.DB  0x20,0x56,0x65,0x72,0x73,0x2E,0x3D,0x25
	.DB  0x2D,0x75,0x20,0x20,0x0,0x5B,0x32,0x31
	.DB  0x32,0x5D,0x55,0x62,0x61,0x74,0x3D,0x25
	.DB  0x2D,0x75,0x2E,0x25,0x2D,0x75,0x56,0x20
	.DB  0x0,0x5B,0x32,0x32,0x30,0x5D,0x4C,0x69
	.DB  0x67,0x2E,0x20,0x64,0x72,0x6F,0x69,0x74
	.DB  0x20,0x0,0x5B,0x32,0x32,0x31,0x5D,0x56
	.DB  0x69,0x72,0x61,0x67,0x65,0x20,0x47,0x39
	.DB  0x30,0x20,0x0,0x5B,0x32,0x32,0x32,0x5D
	.DB  0x56,0x69,0x72,0x61,0x2E,0x20,0x47,0x31
	.DB  0x38,0x30,0x20,0x0,0x5B,0x32,0x32,0x33
	.DB  0x5D,0x56,0x69,0x72,0x61,0x67,0x65,0x20
	.DB  0x44,0x39,0x30,0x20,0x0,0x5B,0x32,0x32
	.DB  0x34,0x5D,0x56,0x69,0x72,0x61,0x2E,0x20
	.DB  0x44,0x31,0x38,0x30,0x20,0x0,0x5B,0x32
	.DB  0x32,0x35,0x5D,0x42,0x61,0x6C,0x61,0x2E
	.DB  0x20,0x5A,0x6F,0x6E,0x65,0x20,0x0,0x5B
	.DB  0x32,0x32,0x36,0x5D,0x4F,0x72,0x69,0x65
	.DB  0x6E,0x2E,0x20,0x53,0x75,0x64,0x20,0x0
	.DB  0x45,0x6E,0x63,0x31,0x3D,0x0,0x45,0x6E
	.DB  0x63,0x32,0x3D,0x0,0x20,0x5B,0x45,0x63
	.DB  0x68,0x61,0x5D,0x0,0x4D,0x53,0x42,0x3D
	.DB  0x25,0x2D,0x78,0x20,0x4C,0x53,0x42,0x3D
	.DB  0x25,0x2D,0x78,0x0
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2080003:
	.DB  0xF8
_0x20C0003:
	.DB  0x76,0x0,0x34,0xD,0x6,0x35,0x4,0x10
	.DB  0x42,0x9F,0x34,0x83,0x2
_0x20C0013:
	.DB  0x76,0x40,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0,0xA0
	.DB  0xA0,0xA0,0x0
_0x20E0003:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x02
	.DW  _TexteMenuHMC6352
	.DW  _0x3*2

	.DW  0x02
	.DW  _Ligne0MenuMode
	.DW  _0x4*2

	.DW  0x02
	.DW  _Ligne0MenuInfos
	.DW  _0x5*2

	.DW  0x02
	.DW  _Ligne0MenuDeplacements
	.DW  _0x6*2

	.DW  0x02
	.DW  _TexteTestSD21
	.DW  _0x7*2

	.DW  0x02
	.DW  _TexteTest1BpsurLed
	.DW  _0x8*2

	.DW  0x02
	.DW  _Ligne1PlusMoins
	.DW  _0x9*2

	.DW  0x02
	.DW  _Ligne1ChoixEntr
	.DW  _0xA*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap
	.DW  _0xB*2

	.DW  0x02
	.DW  _Ligne1ChoixEchap5s
	.DW  _0xC*2

	.DW  0x02
	.DW  _Ligne1ChoixEchapOk
	.DW  _0xD*2

	.DW  0x02
	.DW  _Ligne1ChoixEchapSET
	.DW  _0xE*2

	.DW  0x02
	.DW  _BpPlusSurD0
	.DW  _0xF*2

	.DW  0x02
	.DW  _BpFlecheHSurD1
	.DW  _0x10*2

	.DW  0x02
	.DW  _BpFlecheHSurD2
	.DW  _0x11*2

	.DW  0x02
	.DW  _BpMoinsSurD3
	.DW  _0x12*2

	.DW  0x02
	.DW  _BpSetSurD4
	.DW  _0x13*2

	.DW  0x02
	.DW  _BpOkSurD5
	.DW  _0x14*2

	.DW  0x02
	.DW  _BpEntrSurD6
	.DW  _0x15*2

	.DW  0x02
	.DW  _BpEchSurD7
	.DW  _0x16*2

	.DW  0x01
	.DW  _Menu_1
	.DW  _0x17*2

	.DW  0x06
	.DW  _0x110
	.DW  _0x0*2+656

	.DW  0x08
	.DW  _0x110+6
	.DW  _0x0*2+668

	.DW  0x06
	.DW  _0x110+14
	.DW  _0x0*2+656

	.DW  0x08
	.DW  _0x110+20
	.DW  _0x0*2+668

	.DW  0x0A
	.DW  0x04
	.DW  _0x157*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

	.DW  0x01
	.DW  _TWI_state_G104
	.DW  _0x2080003*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1070000000
	.DW  _0x20E0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/****************************************************************
;Project : PPE Robot Solaire
;Version : 1.2.0
;// --------------------------------------------------------------
;Fichier source : mainTestSISIV2.c
;Date de  cration : 06/01/2010
;Mise  jour le : 22/05/2011
;// --------------------------------------------------------------
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;// --------------------------------------------------------------
;Comments:
;- Mise en oeuvre du protocole I2C sur l'interface TWI
;(Adaptation de la note d'application AVR315 d'ATMEL)
;- Commande d'un afficheur LCD Batron I2C (PCF2119x)
;- Lecture des BP et recopie sur les LED.
;- Test de la carte MD23/MD25(Reglage et commande des moteurs en
;Mode0, lecture et affichage des registres, test de dplacements)
;- Test de la carte SD21
;- Test de la boussole HMC6352
;- Dplacement et orientation au sud
;// --------------------------------------------------------------
;Cross compilateur: CVAVR 2.04.08a
;// --------------------------------------------------------------
;Chip type           : ATmega32
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 512
;****************************************************************/
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// Informations sur le paramtrage du programme
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// Le nombre de dplacement est dfini par
;// #define Nombre_Deplacements_du_Balayage             ?
;// Les paramtres des dplacements doivent tre mmoriss dans le tableau
;// Table_Balayage[Nombre_Deplacements_du_Balayage][4]
;// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;// ===========================================================================================================================
;// Partie dclarative du programme
;// ===========================================================================================================================
;// Bibliothques et dfinitions
;// ===========================================================================================================================
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;// ===========================================================================================================================
;// Bibliothques CVAVR ( rajouter manuellement)
;// ===========================================================================================================================
;#include <stdlib.h>
;#include <stdio.h>				// Fonction sprintf
;#include <math.h>
;#include <string.h>				// Fonctions de traitement des chanes de caractres
;#include <delay.h>				// Fonction temporisation
;// ===========================================================================================================================
;// Bibliothques dveloppes pour la carte SISI ( rajouter manuellement)
;// ===========================================================================================================================
;#include "DriverTWICV2.h"       // Fonctions du drivers TWI adaptes pour CVAVR
;                                // ATTENTION: Vrifier que la taille du buffer est adapte au message (20 par dfaut)
;#include "stdmno.h"             // Fonctions LSBYTE et MSBYTE
;#include "MD23.h"				// Dfinitions des registres de la carte moteur MD23
;#include "LCDBATRON.h"          // Fonctions de lecture/criture des priphriques I2C
;#include "SISISOL.h"            // Gestion de l'IHM SISI
;#include "SD21.h"				// Dfinitions des registres de la carte servo SD21
;#include "TableRob.h"           // Dclaration des tables de valeurs envoyes aux servos
;#include "HMC6352.h"			// Dfinition des registres de la boussole Honeywell HMC6352
;// ===========================================================================================================================
;// Dclarations
;// ===========================================================================================================================
;// Redfinition des adresses (lecture / criture) de la boussole HMC6352 (0x42 par dfaut: en conflit avec les BP de la carte
;// SISI si l'IHM ne dispose pas du rglage des adresses des PCF8574 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! )
;// ---------------------------------------------------------------------------------------------------------------------------
;#define NEW_HMC6352_SLA_W 	0x44 // Ox42 est utilis par le PCF8574 reli aux LEDs sur l'IHM SISIV1 !
;#define	NEW_HMC6352_SLA_R   0x45
;// ---------------------------------------------------------------------------------------------------------------------------
;#ifndef
;#define Null	            0
;#endif
;// ---------------------------------------------------------------------------------------------------------------------------
;// Alias pour la trame de commande des Servos connects  la carte SD21
;// ---------------------------------------------------------------------------------------------------------------------------
;#define NumServo			  Frame_I2C_Servo[1]
;#define RegSpeedValue	      Frame_I2C_Servo[2]
;#define RegPosLByte			  Frame_I2C_Servo[3]
;#define RegPosHByte			  Frame_I2C_Servo[4]
;// ---------------------------------------------------------------------------------------------------------------------------
;// Alias pour la trame de commande des moteurs connects  de la carte MD23 - 25
;// ---------------------------------------------------------------------------------------------------------------------------
;#define	MoteurG			        0
;#define	MoteurD			        1
;// ---------------------------------------------------------------------------------------------------------------------------
;// Nombre de dplacements pendant le balayage
;
;#define Nombre_Deplacements_du_Balayage             16
;#define CodeurG                                     0
;#define CodeurD                                     1
;// ===========================================================================================================================
;
;// ===========================================================================================================================
;// ===========================================================================================================================
;// Constantes en flash
;// ---------------------------------------------------------------------------------------------------------------------------
;// Structure pour l'affichage du nom des registres  (A terminer)
;// flash char Table_Name_Register_MD23[3][7]={"Speed1", "Speed2","Enc1a "};   // changer par une structure
;// ---------------------------------------------------------------------------------------------------------------------------
;// Messages textuels prdfinis
;// ATTENTION: imprativement 16 caractres
;// ---------------------------------------------------------------------------------------------------------------------------
;flash char *Texte_Accueil_Ligne1 	= "   Test SISI    ";
;flash char *Texte_Accueil_Ligne2 	= "[RBSOL 25/05/11]";
;flash char *TexteMenuLedBp			= "[1]Test BP->Led ";
;flash char *TexteMenuMD23			= "[2]Test MD23    ";
;flash char *TexteMenuSD21			= "[3]Test SD21    ";
;flash char *TexteMenuHMC6352        = "[4]HMC6352      ";

	.DSEG
;flash char *Ligne0MenuMode			= "[20]Choix Modes ";
;flash char *Ligne0MenuInfos			= "[21]Aff Infos   ";
;flash char *Ligne0MenuDeplacements  = "[22]Choix Depl. ";
;flash char *TexteTestSD21           = "Cde Servo 1->4  ";
;flash char *TexteTest1BpsurLed	    = "Recopie Bp->Led ";
;flash char *Ligne1PlusMoins			= "[+/-]   [Echap] ";
;flash char *Ligne1ChoixEntr			= "[Entr]          ";
;flash char *Ligne1ChoixEchap		= "        [Echap] ";
;flash char *Ligne1ChoixEchap5s		= "    [Echap 5s!] ";
;flash char *Ligne1ChoixEchapOk		= "[Entr]  [Echap] ";
;flash char *Ligne1ChoixEchapSET		= "[SET]   [Echap] ";
;flash char *BpPlusSurD0				= "+ -> D0 [Echap] ";
;flash char *BpFlecheHSurD1			= "FH-> D1 [Echap] ";
;flash char *BpFlecheHSurD2			= "FB-> D2 [Echap] ";
;flash char *BpMoinsSurD3			= "- -> D3 [Echap] ";
;flash char *BpSetSurD4				= "SET->D4 [Echap] ";
;flash char *BpOkSurD5				= "Ok-> D5 [Echap] ";
;flash char *BpEntrSurD6				= "ENT->D6 [Echap] ";
;flash char *BpEchSurD7				= "ECH->D7 [Echap] ";
;// ===========================================================================================================================
;
;// ===========================================================================================================================
;// ===========================================================================================================================
;// Prototypes des fonctions en cours de test
;// ---------------------------------------------------------------------------------------------------------------------------
;// ===========================================================================================================================
;
;// ===========================================================================================================================
;// ===========================================================================================================================
;// ------------------------------------------ Declare your global variables here ---------------------------------------------
;// ---------------------------------------------------------------------------------------------------------------------------
;// Type				Nom														Description
;// ---------------------------------------------------------------------------------------------------------------------------
;// Etats du graphe des transitions "Menus"
;// ---------------------------------------------------------------------------------------------------------------------------
;// Enumration
;enum TMenu {Menu1_LED_BP, Menu2_MD23, Menu3_SD21, Menu4_HMC6352, Menu20_Mode_MD23, Menu21_Infos_MD23, Menu22_Deplacements,
;Copie_BP_Sur_Led, Choix_Mode_MD23, Reglage_Valeurs_Mode0_MD23, Info_All, Info_Version,  Info_TensionBatt,
;Selection_Deplacements, Test_Deplacements_Elementaires, Balayage, Orientation_Sud, Test_HMC6352, Test_SD21}
;Menu=Menu1_LED_BP, Menu_1=Menu2_MD23;
;// ---------------------------------------------------------------------------------------------------------------------------
;// Boolen
;bit Choix_Moteur=0;			// Permet de permuter le rglage de la vitesse des moteurs dans le menu mode 0
;// ===========================================================================================================================
;
;
;// ===========================================================================================================================
;// ===========================================================================================================================
;// Partie excutive du programme
;// ===========================================================================================================================
;// ===========================================================================================================================
;void main(void)
; 0000 00A7 {

	.CSEG
_main:
; 0000 00A8 // ===========================================================================================================================
; 0000 00A9 // ---------------------------------------------- Declare your local variables here ------------------------------------------
; 0000 00AA // ===========================================================================================================================
; 0000 00AB // Messages pour les composants I2C
; 0000 00AC // ===========================================================================================================================
; 0000 00AD // 1) Messages prdfinis pour les ports I2C PCF8574 associs aux BP et aux LEDs de la carte S_ISI
; 0000 00AE // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00AF // Type 	   		Nom 				       						Description
; 0000 00B0 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00B1 char Frame_I2C_LED_All_Off[]={Add_LED_I2C_W,0xff}; 		// Trame d'extinction des LED {SLA+W=0x40, Data = all Led off}
; 0000 00B2 char Frame_I2C_LED_Switching[]={Add_LED_I2C_W,0x00}; 	// Trame de commande des LED {SLA+W=0x40, Data : Led_On=0
; 0000 00B3                                                         // or Off=1}. Initialisation = All On.
; 0000 00B4 char Frame_I2C_BP_Read[]={Add_BP_I2C_R,0x00}; 			// Trame de lecture des BP {SLA+R=0x43, Data=Nul}
; 0000 00B5 // ===========================================================================================================================
; 0000 00B6 // 2) Liste de messages prdfinis pour le LCD I2C BATRON de la carte SISI
; 0000 00B7 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00B8 // Type 	   		Nom 				       						Description
; 0000 00B9 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00BA //unsigned char Frame_I2C_LCD_BATRON_Clear[]={0x76,0x00,0x01}; 	// Effacement de l'cran {SLA+W=0x76, acces=RegIR, cde=clear}
; 0000 00BB char Frame_I2C_Lcd_Line[19]={0x76,0x40};      	    	        // Trame de texte compose de: {SLA+W=0x76, cde=write to
; 0000 00BC 						 	     								// DDRAM, le texte  afficher = 16 caractres max, Nul }
; 0000 00BD                                                             	// Cette trame est remplie avec le tableau String_to_LCD
; 0000 00BE // ===========================================================================================================================
; 0000 00BF // 3) Liste de messages prdfinis pour la carte MD23
; 0000 00C0 // ===========================================================================================================================
; 0000 00C1 // 30) Initialisation
; 0000 00C2 unsigned char Reset_Encodeurs_MD23[]={MD23_ADD_BASE_W,Reg_Commande, Reset_Encodeur}; // Remise  zro des encodeurs
; 0000 00C3 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00C4 // 31) Modes
; 0000 00C5 unsigned char Mode0_MD23[]={MD23_ADD_BASE_W,Reg_Mode,Mode0};    // Rglage du mode 0
; 0000 00C6 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00C7 // 32) Vitesse des moteurs
; 0000 00C8 unsigned char Speed1[]={MD23_ADD_BASE_W,Reg_Speed1, 128};		// Arrt moteur gauche dans le mode 0
; 0000 00C9 unsigned char Speed2[]={MD23_ADD_BASE_W,Reg_Speed2_Turn, 128};  // Arrt moteur droit dans le mode 0
; 0000 00CA unsigned char Time_OUT_Desable[]={MD23_ADD_BASE_W,Reg_Commande, Desactive_Timeout_Moteurs}; // Dsactivation de la scurit
; 0000 00CB                                                                 // Arrt moteurs si aucune trame n'est reu pendant 2s
; 0000 00CC // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00CD // 33) Lecture des registres
; 0000 00CE unsigned char Read_Reg_MD23_W[]= {MD23_ADD_BASE_W,0};		    // Premire trame  envoyer:
; 0000 00CF 															    // { SLA_W=0xB0, N registre o commence la lecture }
; 0000 00D0 // ===========================================================================================================================
; 0000 00D1 // 4) Message pour la commande des servos
; 0000 00D2 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00D3 // Cette trame est compose de: {@SD21, NumServo, RegSpeedValue, RegPosLByte, RegPosHByte}
; 0000 00D4 unsigned char Frame_I2C_Servo[]={SD21_ADD_BASE_W,Servo1,0,0xE8,0x03};
; 0000 00D5 
; 0000 00D6 // Dtail du contenu de la "trame I2C Servo"
; 0000 00D7 // @SD21			  SLA+W = 0xC2: Adresse de la carte SD21 en criture
; 0000 00D8 // NumServo			  N du registre vitesse du servo  commander, dfinit dans SD21.h (Servo1 par dfaut)
; 0000 00D9 // RegSpeedValue	  Valeur  placer dans le le registre vitesse (Vitesse maxi par dfaut)
; 0000 00DA // RegPosLByte		  Octet de poids faible du mot de commande de la position (Position mini par dfaut)
; 0000 00DB // RegPosHByte		  Octet de poids fort du mot de commande de la position
; 0000 00DC // ===========================================================================================================================
; 0000 00DD // 5) Messages pour la boussole HMC6352
; 0000 00DE // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00DF // Lecture de la direction (comprise entre 0 et 3599 dixime de degrs, code sur deux octets)
; 0000 00E0 unsigned char Frame_I2C_Write_Command_HMC6352[] = {NEW_HMC6352_SLA_W,'A'};      // Commande
; 0000 00E1 unsigned char Frame_I2C_Read_Data_HMC6352[] = {NEW_HMC6352_SLA_R,Null,Null};    // La boussole renvoie deux octets (MSByte et
; 0000 00E2                                                                                 // LSByte)
; 0000 00E3 // ===========================================================================================================================
; 0000 00E4 // Variables diverses
; 0000 00E5 // ===========================================================================================================================
; 0000 00E6 // Type 			Nom 				       			   				Description
; 0000 00E7 // ===========================================================================================================================
; 0000 00E8 // 1) Gestion de la carte MD23
; 0000 00E9 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00EA // Variables utilises pour la gestion de l'affichage sur le LCD:  limitent son rafrachissement!
; 0000 00EB unsigned int Num_Reg_MD23_1 = 0;
; 0000 00EC unsigned char Vitesse_MD23_1 = 1,  BP_I2C_1 = 1, Finesse_1 = 1;
; 0000 00ED unsigned char SpeedMot1_1 = 128, SpeedMot2_1 = 128;
; 0000 00EE signed char Choix_Mode_1 = 1;
; 0000 00EF unsigned char Ubatt_1=0;
; 0000 00F0 unsigned char Version_1=0;
; 0000 00F1 long int TableCodeur_1[2] = {0,0};
; 0000 00F2 unsigned char SelecDeplacement_1 = 0;
; 0000 00F3 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 00F4 // Variables utilises pour la gestion de la carte MD23/25
; 0000 00F5 unsigned int Num_Reg_MD23 = 0;
; 0000 00F6 unsigned char Vitesse_MD23 = 0, BP_I2C = 0,  Finesse = 5 ;
; 0000 00F7 unsigned char SpeedMot1 = 128, SpeedMot2 = 128 ;        // Arrt des moteurs
; 0000 00F8 signed char Choix_Mode = 0;
; 0000 00F9 unsigned char Ubatt = 0;				                // Tension alimentation carte MD23/MD25
; 0000 00FA unsigned char Version = 0;                              // Version du soft de la carte MD23/MD25
; 0000 00FB long int TableCodeur[2] = {0,0};                        // Reprsentatif de la valeur contenue dans les encodeurs
; 0000 00FC                                                         // TableCodeur[0] <- Codeur1(Gauche)   TableCodeur[1] <- Codeur2 (Droit)
; 0000 00FD long int Valeur_Codeur_Stop = 0;                        // Valeur teste lors d'un dplacement lmentaire
; 0000 00FE unsigned char NumeroCodeur = 0;
; 0000 00FF // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0100 // Variable utilises pour les test de dplacement
; 0000 0101 unsigned char SelecDeplacement = 0;                     // Fait voluer le menu dplacement
; 0000 0102 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0103 // ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; 0000 0104 // Table des valeurs utilises pour les diffrents dplacements lors d'un balayage. Valeurs dtermines avec le fichier Excel
; 0000 0105 // "Calcul_parametres_MD23_25_deplacements.xls"
; 0000 0106 // Le nombre de ligne est identifi en haut du fichier source par "Nombre_Deplacements_du_Balayage"
; 0000 0107 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0108 /* Essai 1 ok
; 0000 0109 unsigned int Table_Balayage[Nombre_Deplacements_du_Balayage][4] =
; 0000 010A                                      {  // Speed1,Speed2,ValeurCodeurStop, CodeurRfrent
; 0000 010B                                         {151,151,2292,CodeurG},    // Dplacement 1 : Ligne droite, D = 2m, V = 20cm/s
; 0000 010C                                         {173,128,1656,CodeurG},    // Dplacement 2 : Virage 180D, R = 23cm , V = 20cm/s
; 0000 010D                                         {151,151,1719,CodeurG},    // Dplacement 3 : Ligne droite, D = 1,5m, V = 20cm/s
; 0000 010E                                         {128,173,1656,CodeurD},    // Dplacement 4 : Virage 180G, R = 23cm , V = 20cm/s
; 0000 010F                                         {128,173,828,CodeurD},     // Dplacement 5 : Virage 90G, R = 23cm , V = 20cm/s
; 0000 0110                                         {128,128,100,CodeurG}      // Arrt !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 0111                                      };
; 0000 0112 */
; 0000 0113 // Essai 2 : Cartech'ino
; 0000 0114 unsigned int Table_Balayage[Nombre_Deplacements_du_Balayage][4] =
; 0000 0115                                      {  // Speed1, Speed2, ValeurCodeurStop, CodeurRfrent
; 0000 0116                                         {151,151,5137,CodeurG},    // Dplacement 1 : Ligne droite, D = 4,5m, V = 20cm/s
; 0000 0117                                         {171,130,1768,CodeurG},    // Dplacement 2 : Virage 180D, R = 25cm , V = 20cm/s
; 0000 0118                                         {151,151,4584,CodeurG},    // Dplacement 3 : Ligne droite, D = 4m, V = 20cm/s
; 0000 0119                                         {130,171,1768,CodeurD},    // Dplacement 4 : Virage 180G, R = 25cm , V = 20cm/s
; 0000 011A                                         {151,151,4584,CodeurG},    // Dplacement 5 : Ligne droite, D = 4m, V = 20cm/s
; 0000 011B                                         {171,130,1768,CodeurG},    // Dplacement 6 : Virage 180D, R = 25cm , V = 20cm/s
; 0000 011C                                         {151,151,4584,CodeurG},    // Dplacement 7 : Ligne droite, D = 4m, V = 20cm/s
; 0000 011D                                         {130,171,1768,CodeurD},    // Dplacement 8 : Virage 180G, R = 25cm , V = 20cm/s
; 0000 011E                                         {151,151,4584,CodeurG},    // Dplacement 9 : Ligne droite, D = 4m, V = 20cm/s
; 0000 011F                                         {171,130,1768,CodeurG},    // Dplacement 10 : Virage 180D, R = 25cm , V = 20cm/s
; 0000 0120                                         {151,151,4584,CodeurG},    // Dplacement 11: Ligne droite, D = 4m, V = 20cm/s
; 0000 0121                                         {130,171,1768,CodeurD},    // Dplacement 12 : Virage 180G, R = 25cm , V = 20cm/s
; 0000 0122                                         {151,151,4584,CodeurG},    // Dplacement 13 : Ligne droite, D = 4m, V = 20cm/s
; 0000 0123                                         {171,130,1768,CodeurG},    // Dplacement 14 : Virage 180D, R = 25cm , V = 20cm/s
; 0000 0124                                         {151,151,5137,CodeurG},    // Dplacement 15: Ligne droite, D = 4,5m, V = 20cm/s
; 0000 0125                                         {128,128,100,CodeurG}      // Arrt !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 0126                                      };
; 0000 0127 // Speed1 = Vitesse moteur Gauche,
; 0000 0128 // Speed2 = Vitesse moteur Droit,
; 0000 0129 // ValeurCodeurStop = Valeur maximum que doit atteindre le codeur rfrent avant un changement de mouvement
; 0000 012A // CodeurRfrent = Codeur test pour arrter le mouvement
; 0000 012B // ---------------------------------------------------------------------------------------------------------------------------
; 0000 012C // ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; 0000 012D // ---------------------------------------------------------------------------------------------------------------------------
; 0000 012E char AfficheDeplacement1[11];         // Tableau permettant d'afficher le contenu du codeur Gauche
; 0000 012F char AfficheDeplacement2[11];         // Tableau permettant d'afficher le contenu du codeur Droit
; 0000 0130 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0131 // Reoit le contenu des registres de la carte MD23/MD25. Liste ci-dessous (dcrite dans MD23.h)
; 0000 0132 // Speed1, Speed2_Turn, Enc1a, Enc1b, Enc1c, Enc1d, Enc2a, Enc2b, Enc2c, Enc2d, Ubatt, IMot1, IMot2, SoftRev,AccRate,Mode,Cde
; 0000 0133 unsigned char Table_Registers_MD23[]={MD23_ADD_BASE_R,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
; 0000 0134 // ===========================================================================================================================
; 0000 0135 // 2) Gestion du LCD BATRON
; 0000 0136 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0137 char Buffer_for_LCD_Line0[17], Buffer_for_LCD_Line1[17];        // Reoivent les deux lignes de texte  envoyer  l'afficheur
; 0000 0138 															    // (16 caractres max. + Nul)
; 0000 0139 // ===========================================================================================================================
; 0000 013A // 3) Gestion de la carte SD21
; 0000 013B // ---------------------------------------------------------------------------------------------------------------------------
; 0000 013C unsigned char Vitesse = 5;				    // Vitesse de dplacement du servo
; 0000 013D unsigned int tempo = 1000;                  // Attente entre deux transmission : doit tre > 20ms
; 0000 013E unsigned int i = 0;						    // Variable de boucle
; 0000 013F // ===========================================================================================================================
; 0000 0140 // 4) Gestion de la boussole HMC6352
; 0000 0141 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0142 // Variables utilises pour la gestion de l'affichage sur le LCD:  limitent son rafrachissement!
; 0000 0143 unsigned char Direction_MSB_1 = 0, Direction_LSB_1 = 0;
; 0000 0144 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0145 unsigned char Direction_MSB = 0,  Direction_LSB = 0;    // Valeur de l'angle renvoy par la boussole HMC6352
; 0000 0146 unsigned int AngleEnDegreFoisDix=0;                     // Calcul de l'angle dlivr par la boussole en 1/1000 soit
; 0000 0147                                                         // AngleEnDegreFoisDix = 256*MSB + LSB
; 0000 0148 char AfficheAngle[] = {"0000"};                         // Reprsentation textuelle de AngleEnDegreFoisDix
; 0000 0149 // --------------------------------------------------------------------------------------------------------------------------
; 0000 014A // ===========================================================================================================================
; 0000 014B 
; 0000 014C 
; 0000 014D // ===========================================================================================================================
; 0000 014E // ===================================================== Initialisations =====================================================
; 0000 014F // ===========================================================================================================================
; 0000 0150 // Initialisation de l'interface TWI en mode Standby
; 0000 0151 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0152 TWI_Master_Initialise();
	SBIW R28,51
	SUBI R29,1
	__GETWRN 24,25,307
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x18*2)
	LDI  R31,HIGH(_0x18*2)
	CALL __INITLOCW
;	Frame_I2C_LED_All_Off -> Y+305
;	Frame_I2C_LED_Switching -> Y+303
;	Frame_I2C_BP_Read -> Y+301
;	Frame_I2C_Lcd_Line -> Y+282
;	Reset_Encodeurs_MD23 -> Y+279
;	Mode0_MD23 -> Y+276
;	Speed1 -> Y+273
;	Speed2 -> Y+270
;	Time_OUT_Desable -> Y+267
;	Read_Reg_MD23_W -> Y+265
;	Frame_I2C_Servo -> Y+260
;	Frame_I2C_Write_Command_HMC6352 -> Y+258
;	Frame_I2C_Read_Data_HMC6352 -> Y+255
;	Num_Reg_MD23_1 -> R16,R17
;	Vitesse_MD23_1 -> R19
;	BP_I2C_1 -> R18
;	Finesse_1 -> R21
;	SpeedMot1_1 -> R20
;	SpeedMot2_1 -> Y+254
;	Choix_Mode_1 -> Y+253
;	Ubatt_1 -> Y+252
;	Version_1 -> Y+251
;	TableCodeur_1 -> Y+243
;	SelecDeplacement_1 -> Y+242
;	Num_Reg_MD23 -> Y+240
;	Vitesse_MD23 -> Y+239
;	BP_I2C -> Y+238
;	Finesse -> Y+237
;	SpeedMot1 -> Y+236
;	SpeedMot2 -> Y+235
;	Choix_Mode -> Y+234
;	Ubatt -> Y+233
;	Version -> Y+232
;	TableCodeur -> Y+224
;	Valeur_Codeur_Stop -> Y+220
;	NumeroCodeur -> Y+219
;	SelecDeplacement -> Y+218
;	Table_Balayage -> Y+90
;	AfficheDeplacement1 -> Y+79
;	AfficheDeplacement2 -> Y+68
;	Table_Registers_MD23 -> Y+50
;	Buffer_for_LCD_Line0 -> Y+33
;	Buffer_for_LCD_Line1 -> Y+16
;	Vitesse -> Y+15
;	tempo -> Y+13
;	i -> Y+11
;	Direction_MSB_1 -> Y+10
;	Direction_LSB_1 -> Y+9
;	Direction_MSB -> Y+8
;	Direction_LSB -> Y+7
;	AngleEnDegreFoisDix -> Y+5
;	AfficheAngle -> Y+0
	__GETWRN 16,17,0
	LDI  R19,1
	LDI  R18,1
	LDI  R21,1
	LDI  R20,128
	CALL _TWI_Master_Initialise
; 0000 0153 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0154 // Global enable interrupts     // ATTENTION !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
; 0000 0155 #asm("sei")					    // L'autorisation des interruptions doit se faire aprs l'initialisation de l'interface TWI
	sei
; 0000 0156 // ===========================================================================================================================
; 0000 0157 TWI_Start_Transc_With_Data(Frame_I2C_LED_All_Off,sizeof(Frame_I2C_LED_All_Off)); // Extinction des LEDs de la carte SISI
	MOVW R30,R28
	SUBI R30,LOW(-(305))
	SBCI R31,HIGH(-(305))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0158 // ===========================================================================================================================
; 0000 0159 // Initialisation de l'afficheur I2C BATRON
; 0000 015A // ---------------------------------------------------------------------------------------------------------------------------
; 0000 015B Init_LCD_I2C_BATRON();
	CALL _Init_LCD_I2C_BATRON
; 0000 015C // ===========================================================================================================================
; 0000 015D // Initialisation des registres de  la carte MD23
; 0000 015E // ---------------------------------------------------------------------------------------------------------------------------
; 0000 015F TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(279))
	SBCI R31,HIGH(-(279))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0160 //TWI_Start_Transc_With_Data(Time_OUT_Desable,sizeof(Time_OUT_Desable)); // Dsactivation de la scurit moteur
; 0000 0161 TWI_Start_Transc_With_Data(Mode0_MD23,sizeof(Mode0_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(276))
	SBCI R31,HIGH(-(276))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0162 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0163 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0164 // ===========================================================================================================================
; 0000 0165 // Affichage d'un message d'accueil
; 0000 0166 // ---------------------------------------------------------------------------------------------------------------------------
; 0000 0167 sprintf(Buffer_for_LCD_Line0,Texte_Accueil_Ligne1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R5
	ST   -Y,R4
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0168 sprintf(Buffer_for_LCD_Line1,Texte_Accueil_Ligne2);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R7
	ST   -Y,R6
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0169 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 016A delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 016B // ===========================================================================================================================
; 0000 016C 
; 0000 016D // ===========================================================================================================================
; 0000 016E // ================================================ Boucle principale ========================================================
; 0000 016F // ===========================================================================================================================
; 0000 0170 while (1)
_0x19:
; 0000 0171       {
; 0000 0172 // ==========================================================================================================================
; 0000 0173 // ---------------------------------------------  Champ Lecture des donnes -------------------------------------------------
; 0000 0174 // Lecture de l'tat des boutons-poussoir (BP)
; 0000 0175 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0176 // Lecture des BP pour affichage sur les LED
; 0000 0177 	TWI_Start_Transc_With_Data(Frame_I2C_BP_Read,1);          // Envoi de l'octet d'adresse des BP: SLA+R=0x43
	MOVW R30,R28
	SUBI R30,LOW(-(301))
	SBCI R31,HIGH(-(301))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0178 // Rcupration de l'octet reprsentatif de l'tat des BP
; 0000 0179 	TWI_Get_Data_From_Transceiver(Frame_I2C_BP_Read,sizeof(Frame_I2C_BP_Read));
	MOVW R30,R28
	SUBI R30,LOW(-(301))
	SBCI R31,HIGH(-(301))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 017A // Lecture des BP avec gestion anti-rebond pour parcourir les menus
; 0000 017B     BP_I2C = Lire_BP_I2C();
	CALL _Lire_BP_I2C
	__PUTB1SX 238
; 0000 017C // --------------------------------------------------------------------------------------------------------------------------
; 0000 017D // Lecture des registres de la carte MD23
; 0000 017E    if (Menu != Reglage_Valeurs_Mode0_MD23)
	LDS  R26,_Menu
	CPI  R26,LOW(0x9)
	BREQ _0x1C
; 0000 017F    {                                                         // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
; 0000 0180 	TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
	MOVW R30,R28
	SUBI R30,LOW(-(265))
	SBCI R31,HIGH(-(265))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0181    	TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture
	MOVW R30,R28
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0182 	TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
	MOVW R30,R28
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 0183    }
; 0000 0184 // ==========================================================================================================================
; 0000 0185 // --------------------------------------------------- Champ Traitement------------------------------------------------------
; 0000 0186     switch(Menu)
_0x1C:
	LDS  R30,_Menu
; 0000 0187     {// Dbut du switch1
; 0000 0188 // -------------------------------------------------Dbut Menus droulants---------------------------------------------------
; 0000 0189 // Dbut des menus Niveau 1 -------------------------------------------------------------------------------------------------
; 0000 018A // ==========================================================================================================================
; 0000 018B // Menu [1] : Choix du test des Led et des BP (Recopie de l'tat des BP sur les LED)
; 0000 018C // ==========================================================================================================================
; 0000 018D        case Menu1_LED_BP : if (Menu_1 != Menu)
	CPI  R30,0
	BREQ PC+3
	JMP _0x20
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x21
; 0000 018E        		{
; 0000 018F                 sprintf(Buffer_for_LCD_Line0,TexteMenuLedBp);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R9
	ST   -Y,R8
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0190 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0191 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0192 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0193        		}
; 0000 0194        		switch (BP_I2C)
_0x21:
	__GETB1SX 238
; 0000 0195 				{
; 0000 0196 					case ENTR_I2C: Menu = Copie_BP_Sur_Led;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x25
	LDI  R30,LOW(7)
	RJMP _0x13C
; 0000 0197 					case FlecheH_I2C: Menu = Menu4_HMC6352;  break;     // touche flche haut
_0x25:
	CPI  R30,LOW(0x2)
	BRNE _0x26
	LDI  R30,LOW(3)
	RJMP _0x13C
; 0000 0198 					case FlecheB_I2C: Menu = Menu2_MD23;  break;        // touche flche bas
_0x26:
	CPI  R30,LOW(0x4)
	BRNE _0x28
	LDI  R30,LOW(1)
	RJMP _0x13C
; 0000 0199 					default: Menu = Menu1_LED_BP;
_0x28:
	LDI  R30,LOW(0)
_0x13C:
	STS  _Menu,R30
; 0000 019A 				}
; 0000 019B 			Menu_1 = Menu1_LED_BP;
	LDI  R30,LOW(0)
	JMP  _0x13D
; 0000 019C        break;
; 0000 019D // ==========================================================================================================================
; 0000 019E // Menu [2] : Choix des test de la carte MD23/25
; 0000 019F // ==========================================================================================================================
; 0000 01A0        case Menu2_MD23 : if (Menu_1 != Menu)
_0x20:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x29
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x2A
; 0000 01A1        		{
; 0000 01A2                 sprintf(Buffer_for_LCD_Line0,TexteMenuMD23);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R11
	ST   -Y,R10
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01A3 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01A4 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01A5 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01A6        		}
; 0000 01A7        		switch (BP_I2C)
_0x2A:
	__GETB1SX 238
; 0000 01A8 				{
; 0000 01A9 					case ENTR_I2C: Menu = Menu20_Mode_MD23;  break;     // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x2E
	LDI  R30,LOW(4)
	RJMP _0x13E
; 0000 01AA 					case FlecheH_I2C: Menu = Menu1_LED_BP;  break;      // touche flche haut
_0x2E:
	CPI  R30,LOW(0x2)
	BRNE _0x2F
	LDI  R30,LOW(0)
	RJMP _0x13E
; 0000 01AB 					case FlecheB_I2C: Menu = Menu3_SD21;  break;        // touche flche bas
_0x2F:
	CPI  R30,LOW(0x4)
	BRNE _0x31
	LDI  R30,LOW(2)
	RJMP _0x13E
; 0000 01AC 					default: Menu = Menu2_MD23 ;
_0x31:
	LDI  R30,LOW(1)
_0x13E:
	STS  _Menu,R30
; 0000 01AD 				}
; 0000 01AE 			Menu_1 = Menu2_MD23 ;
	LDI  R30,LOW(1)
	JMP  _0x13D
; 0000 01AF        break;
; 0000 01B0 // ==========================================================================================================================
; 0000 01B1 // Menu [3] : Choix du test de la carte SD21
; 0000 01B2 // ==========================================================================================================================
; 0000 01B3        case Menu3_SD21 : if (Menu_1 != Menu)
_0x29:
	CPI  R30,LOW(0x2)
	BREQ PC+3
	JMP _0x32
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x33
; 0000 01B4        		{
; 0000 01B5                 sprintf(Buffer_for_LCD_Line0,TexteMenuSD21);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R13
	ST   -Y,R12
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01B6 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01B7 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01B8 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01B9        		}
; 0000 01BA        		switch (BP_I2C)
_0x33:
	__GETB1SX 238
; 0000 01BB 				{
; 0000 01BC 					case ENTR_I2C: Menu = Test_SD21;  break;           // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x37
	LDI  R30,LOW(18)
	RJMP _0x13F
; 0000 01BD 					case FlecheH_I2C: Menu = Menu2_MD23;  break;       // touche flche haut
_0x37:
	CPI  R30,LOW(0x2)
	BRNE _0x38
	LDI  R30,LOW(1)
	RJMP _0x13F
; 0000 01BE 					case FlecheB_I2C: Menu = Menu4_HMC6352;  break;    // touche flche bas
_0x38:
	CPI  R30,LOW(0x4)
	BRNE _0x3A
	LDI  R30,LOW(3)
	RJMP _0x13F
; 0000 01BF 					default: Menu = Menu3_SD21 ;
_0x3A:
	LDI  R30,LOW(2)
_0x13F:
	STS  _Menu,R30
; 0000 01C0 				}
; 0000 01C1 			Menu_1 = Menu3_SD21 ;
	LDI  R30,LOW(2)
	JMP  _0x13D
; 0000 01C2        break;
; 0000 01C3 // ==========================================================================================================================
; 0000 01C4 // Menu [4] : Choix du test de la boussole HMC6352
; 0000 01C5 // ==========================================================================================================================
; 0000 01C6        case Menu4_HMC6352 : if (Menu_1 != Menu)
_0x32:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x3B
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x3C
; 0000 01C7        		{
; 0000 01C8                 sprintf(Buffer_for_LCD_Line0,TexteMenuHMC6352);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteMenuHMC6352
	LDS  R31,_TexteMenuHMC6352+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01C9 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEntr);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEntr
	LDS  R31,_Ligne1ChoixEntr+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01CA 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01CB 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01CC        		}
; 0000 01CD        		switch (BP_I2C)
_0x3C:
	__GETB1SX 238
; 0000 01CE 				{
; 0000 01CF 					case ENTR_I2C: Menu = Test_HMC6352;  break;         // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x40
	LDI  R30,LOW(17)
	RJMP _0x140
; 0000 01D0 					case FlecheH_I2C: Menu = Menu3_SD21;  break;        // touche flche haut
_0x40:
	CPI  R30,LOW(0x2)
	BRNE _0x41
	LDI  R30,LOW(2)
	RJMP _0x140
; 0000 01D1 					case FlecheB_I2C: Menu = Menu1_LED_BP;  break;      // touche flche bas
_0x41:
	CPI  R30,LOW(0x4)
	BRNE _0x43
	LDI  R30,LOW(0)
	RJMP _0x140
; 0000 01D2 					default: Menu = Menu4_HMC6352 ;
_0x43:
	LDI  R30,LOW(3)
_0x140:
	STS  _Menu,R30
; 0000 01D3 				}
; 0000 01D4 			Menu_1 = Menu4_HMC6352 ;
	LDI  R30,LOW(3)
	JMP  _0x13D
; 0000 01D5        break;
; 0000 01D6 // --------------------------------------------------------------------------------------------------------------------------
; 0000 01D7 // Fin des menus niveau 1
; 0000 01D8 // ==========================================================================================================================
; 0000 01D9 // Sous menus(Niveau 2) -----------------------------------------------------------------------------------------------------
; 0000 01DA // ==========================================================================================================================
; 0000 01DB // Sous menu [20]: Choix du mode de commande des moteurs de la carte MD23/25
; 0000 01DC // ==========================================================================================================================
; 0000 01DD 		case Menu20_Mode_MD23 : if (Menu_1 != Menu)
_0x3B:
	CPI  R30,LOW(0x4)
	BREQ PC+3
	JMP _0x44
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE PC+3
	JMP _0x45
; 0000 01DE 			{
; 0000 01DF 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuMode);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuMode
	LDS  R31,_Ligne0MenuMode+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01E0 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01E1 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01E2 				LCD_I2C_BATRON_gotoxy(0,15);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _LCD_I2C_BATRON_gotoxy
; 0000 01E3 				Built_Strng_Fram_I2C_LCDBATRON(Frame_I2C_Lcd_Line, Buffer_for_LCD_Line0, strlen(Buffer_for_LCD_Line0));
	MOVW R30,R28
	SUBI R30,LOW(-(282))
	SBCI R31,HIGH(-(282))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,35
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,37
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	CALL _Built_Strng_Fram_I2C_LCDBATRON
; 0000 01E4 				TWI_Start_Transc_With_Data(Frame_I2C_Lcd_Line,strlen(Frame_I2C_Lcd_Line));
	MOVW R30,R28
	SUBI R30,LOW(-(282))
	SBCI R31,HIGH(-(282))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(284))
	SBCI R31,HIGH(-(284))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 01E5 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01E6 			}
; 0000 01E7 
; 0000 01E8 			switch (BP_I2C)
_0x45:
	__GETB1SX 238
; 0000 01E9 				{
; 0000 01EA 					case ENTR_I2C: Menu = Choix_Mode_MD23;  break;         // touche Enter
	CPI  R30,LOW(0x40)
	BRNE _0x49
	LDI  R30,LOW(8)
	RJMP _0x141
; 0000 01EB 					case FlecheH_I2C: Menu = Menu22_Deplacements;  break;  // touche flche haut
_0x49:
	CPI  R30,LOW(0x2)
	BRNE _0x4A
	LDI  R30,LOW(6)
	RJMP _0x141
; 0000 01EC 					case FlecheB_I2C: Menu = Menu21_Infos_MD23;  break;    // touche flche bas
_0x4A:
	CPI  R30,LOW(0x4)
	BRNE _0x4B
	LDI  R30,LOW(5)
	RJMP _0x141
; 0000 01ED 					case ECHAP_I2C : Menu = Menu2_MD23; break;             // touche ECHAP
_0x4B:
	CPI  R30,LOW(0x80)
	BRNE _0x4D
	LDI  R30,LOW(1)
	RJMP _0x141
; 0000 01EE 					default: Menu = Menu20_Mode_MD23 ;
_0x4D:
	LDI  R30,LOW(4)
_0x141:
	STS  _Menu,R30
; 0000 01EF 				}
; 0000 01F0 			Menu_1 = Menu20_Mode_MD23;
	LDI  R30,LOW(4)
	JMP  _0x13D
; 0000 01F1 		break;
; 0000 01F2 // ==========================================================================================================================
; 0000 01F3 // Sous menu [21] : Choix de l'affichage du contenu des registres de la carte MD23/25
; 0000 01F4 // ==========================================================================================================================
; 0000 01F5 		case Menu21_Infos_MD23: if (Menu_1 != Menu)
_0x44:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x4E
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x4F
; 0000 01F6 			{
; 0000 01F7 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuInfos);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuInfos
	LDS  R31,_Ligne0MenuInfos+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01F8 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01F9 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 01FA 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 01FB 			}
; 0000 01FC 
; 0000 01FD 			switch (BP_I2C)
_0x4F:
	__GETB1SX 238
; 0000 01FE 				{
; 0000 01FF 					case ENTR_I2C: Menu = Info_All;  break;
	CPI  R30,LOW(0x40)
	BRNE _0x53
	LDI  R30,LOW(10)
	RJMP _0x142
; 0000 0200 					case FlecheH_I2C: Menu = Menu20_Mode_MD23;  break;
_0x53:
	CPI  R30,LOW(0x2)
	BRNE _0x54
	LDI  R30,LOW(4)
	RJMP _0x142
; 0000 0201 					case FlecheB_I2C: Menu = Menu22_Deplacements;  break;
_0x54:
	CPI  R30,LOW(0x4)
	BRNE _0x55
	LDI  R30,LOW(6)
	RJMP _0x142
; 0000 0202 					case ECHAP_I2C : Menu = Menu2_MD23; break;
_0x55:
	CPI  R30,LOW(0x80)
	BRNE _0x57
	LDI  R30,LOW(1)
	RJMP _0x142
; 0000 0203 					default: Menu = Menu21_Infos_MD23 ;
_0x57:
	LDI  R30,LOW(5)
_0x142:
	STS  _Menu,R30
; 0000 0204 				}
; 0000 0205 
; 0000 0206 			Menu_1 = Menu21_Infos_MD23 ;
	LDI  R30,LOW(5)
	JMP  _0x13D
; 0000 0207 		break;
; 0000 0208 // ==========================================================================================================================
; 0000 0209 // Sous menu [22] : Choix d'un test de dplacement
; 0000 020A // ==========================================================================================================================
; 0000 020B 		case Menu22_Deplacements: if (Menu_1 != Menu)
_0x4E:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x58
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x59
; 0000 020C 			{
; 0000 020D 				sprintf(Buffer_for_LCD_Line0,Ligne0MenuDeplacements);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne0MenuDeplacements
	LDS  R31,_Ligne0MenuDeplacements+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 020E 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 020F 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0210 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0211 			}
; 0000 0212 
; 0000 0213 			switch (BP_I2C)
_0x59:
	__GETB1SX 238
; 0000 0214 				{
; 0000 0215 					case ENTR_I2C: Menu = Selection_Deplacements;  break;
	CPI  R30,LOW(0x40)
	BRNE _0x5D
	LDI  R30,LOW(13)
	RJMP _0x143
; 0000 0216 					case FlecheH_I2C: Menu = Menu21_Infos_MD23;  break;
_0x5D:
	CPI  R30,LOW(0x2)
	BRNE _0x5E
	LDI  R30,LOW(5)
	RJMP _0x143
; 0000 0217 					case FlecheB_I2C: Menu = Menu20_Mode_MD23;  break;
_0x5E:
	CPI  R30,LOW(0x4)
	BRNE _0x5F
	LDI  R30,LOW(4)
	RJMP _0x143
; 0000 0218 					case ECHAP_I2C : Menu = Menu2_MD23; break;
_0x5F:
	CPI  R30,LOW(0x80)
	BRNE _0x61
	LDI  R30,LOW(1)
	RJMP _0x143
; 0000 0219 					default: Menu = Menu22_Deplacements ;
_0x61:
	LDI  R30,LOW(6)
_0x143:
	STS  _Menu,R30
; 0000 021A 				}
; 0000 021B 			Menu_1 = Menu22_Deplacements ;
	LDI  R30,LOW(6)
	JMP  _0x13D
; 0000 021C 		break;
; 0000 021D // --------------------------------------------------------------------------------------------------------------------------
; 0000 021E // Fin des sous menus
; 0000 021F // ==========================================================================================================================
; 0000 0220 // Tests --------------------------------------------------------------------------------------------------------------------
; 0000 0221 // ==========================================================================================================================
; 0000 0222 // Test associ  [1]: Affichage du nom du BP et de la LED  laquelle il est associ sur le LCD
; 0000 0223 // ==========================================================================================================================
; 0000 0224 			case Copie_BP_Sur_Led :
_0x58:
	CPI  R30,LOW(0x7)
	BREQ PC+3
	JMP _0x62
; 0000 0225               if ((Menu_1 != Menu) || ((BP_I2C != BP_I2C_1) && (BP_I2C != 0xFF)))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x64
	__GETB2SX 238
	CP   R18,R26
	BREQ _0x65
	CPI  R26,LOW(0xFF)
	BRNE _0x64
_0x65:
	RJMP _0x63
_0x64:
; 0000 0226 				{
; 0000 0227 				 sprintf(Buffer_for_LCD_Line0,TexteTest1BpsurLed);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteTest1BpsurLed
	LDS  R31,_TexteTest1BpsurLed+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0228 
; 0000 0229 				 switch (BP_I2C)
	__GETB1SX 238
; 0000 022A 				  {
; 0000 022B 				 	case ENTR_I2C : sprintf(Buffer_for_LCD_Line1,BpEntrSurD6); break;
	CPI  R30,LOW(0x40)
	BRNE _0x6B
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEntrSurD6
	LDS  R31,_BpEntrSurD6+1
	RJMP _0x144
; 0000 022C 				 	case FlecheH_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD1); break;
_0x6B:
	CPI  R30,LOW(0x2)
	BRNE _0x6C
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD1
	LDS  R31,_BpFlecheHSurD1+1
	RJMP _0x144
; 0000 022D 				 	case FlecheB_I2C : sprintf(Buffer_for_LCD_Line1,BpFlecheHSurD2); break;
_0x6C:
	CPI  R30,LOW(0x4)
	BRNE _0x6D
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpFlecheHSurD2
	LDS  R31,_BpFlecheHSurD2+1
	RJMP _0x144
; 0000 022E 				 	case ECHAP_I2C : sprintf(Buffer_for_LCD_Line1,BpEchSurD7); break;
_0x6D:
	CPI  R30,LOW(0x80)
	BRNE _0x6E
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpEchSurD7
	LDS  R31,_BpEchSurD7+1
	RJMP _0x144
; 0000 022F 				 	case OK_I2C : sprintf(Buffer_for_LCD_Line1,BpOkSurD5); break;
_0x6E:
	CPI  R30,LOW(0x20)
	BRNE _0x6F
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpOkSurD5
	LDS  R31,_BpOkSurD5+1
	RJMP _0x144
; 0000 0230 				 	case MOINS_I2C: sprintf(Buffer_for_LCD_Line1,BpMoinsSurD3); break;
_0x6F:
	CPI  R30,LOW(0x8)
	BRNE _0x70
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpMoinsSurD3
	LDS  R31,_BpMoinsSurD3+1
	RJMP _0x144
; 0000 0231 				 	case PLUS_I2C: sprintf(Buffer_for_LCD_Line1,BpPlusSurD0); break;
_0x70:
	CPI  R30,LOW(0x1)
	BRNE _0x71
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpPlusSurD0
	LDS  R31,_BpPlusSurD0+1
	RJMP _0x144
; 0000 0232 				 	case SET_I2C: sprintf(Buffer_for_LCD_Line1,BpSetSurD4); break;
_0x71:
	CPI  R30,LOW(0x10)
	BRNE _0x72
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_BpSetSurD4
	LDS  R31,_BpSetSurD4+1
	RJMP _0x144
; 0000 0233 				 	case 0 : sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap );
_0x72:
	CPI  R30,0
	BRNE _0x6A
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
_0x144:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0234 				  }
_0x6A:
; 0000 0235 
; 0000 0236 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0237 					BP_I2C_1 = BP_I2C;
	__GETBRSX 18,238
; 0000 0238 			   	 }
; 0000 0239 
; 0000 023A         		if (BP_I2C == ECHAP_I2C)
_0x63:
	__GETB2SX 238
	CPI  R26,LOW(0x80)
	BRNE _0x74
; 0000 023B         		  {
; 0000 023C         			Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 302
	COM  R30
	ST   X,R30
; 0000 023D         			TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,2);  	// Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 023E         			delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 023F         			Menu = Menu1_LED_BP;
	LDI  R30,LOW(0)
	RJMP _0x145
; 0000 0240         		  }
; 0000 0241         		else  Menu = Copie_BP_Sur_Led;
_0x74:
	LDI  R30,LOW(7)
_0x145:
	STS  _Menu,R30
; 0000 0242 
; 0000 0243 			    Menu_1 = Copie_BP_Sur_Led;
	LDI  R30,LOW(7)
	JMP  _0x13D
; 0000 0244 			break;
; 0000 0245 // ==========================================================================================================================
; 0000 0246 // Rglage(s) associ(s) au sous-menu "[20] Choix_Modes" : Rglage du mode de commande des moteurs
; 0000 0247 // (Le premier rglage est "[200] Mode 0"
; 0000 0248 // ==========================================================================================================================
; 0000 0249 	        case Choix_Mode_MD23: if ((Menu_1 != Menu) || (Choix_Mode_1 != Choix_Mode))
_0x62:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x76
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x78
	__GETB1SX 234
	__GETB2SX 253
	CP   R30,R26
	BREQ _0x77
_0x78:
; 0000 024A 	          {
; 0000 024B 	        	 sprintf(Buffer_for_LCD_Line0,"Choix: Mode%-u    ",Choix_Mode);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,425
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 238
	CALL __CBD1
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 024C 	        	 sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchapOk);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapOk
	LDS  R31,_Ligne1ChoixEchapOk+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 024D 	        	 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 024E 	        	 Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 024F 	        	 Choix_Mode_1 = Choix_Mode;
	__GETB1SX 234
	__PUTB1SX 253
; 0000 0250 	          }
; 0000 0251 
; 0000 0252 	          switch (BP_I2C)
_0x77:
	__GETB1SX 238
; 0000 0253 				{
; 0000 0254 					case ECHAP_I2C : Menu=Menu20_Mode_MD23; break;  // touche ECHAP
	CPI  R30,LOW(0x80)
	BRNE _0x7D
	LDI  R30,LOW(4)
	RJMP _0x146
; 0000 0255 					case FlecheH_I2C: Choix_Mode = Choix_Mode - 1; if (Choix_Mode < 0) Choix_Mode=3;  break;
_0x7D:
	CPI  R30,LOW(0x2)
	BRNE _0x7E
	__GETB1SX 234
	SUBI R30,LOW(1)
	__PUTB1SX 234
	__GETB2SX 234
	CPI  R26,0
	BRGE _0x7F
	LDI  R30,LOW(3)
	__PUTB1SX 234
_0x7F:
	RJMP _0x7C
; 0000 0256 					case FlecheB_I2C:  Choix_Mode = Choix_Mode + 1; if (Choix_Mode > 3) Choix_Mode=0 ;  break;
_0x7E:
	CPI  R30,LOW(0x4)
	BRNE _0x80
	__GETB1SX 234
	SUBI R30,-LOW(1)
	__PUTB1SX 234
	__GETB2SX 234
	CPI  R26,LOW(0x4)
	BRLT _0x81
	LDI  R30,LOW(0)
	__PUTB1SX 234
_0x81:
	RJMP _0x7C
; 0000 0257 					case ENTR_I2C: if (Choix_Mode == 0)
_0x80:
	CPI  R30,LOW(0x40)
	BRNE _0x84
	__GETB1SX 234
	CPI  R30,0
	BRNE _0x83
; 0000 0258                                         {SpeedMot1 = 128; SpeedMot2 = 128; Menu = Reglage_Valeurs_Mode0_MD23;}
	LDI  R30,LOW(128)
	__PUTB1SX 236
	__PUTB1SX 235
	LDI  R30,LOW(9)
	STS  _Menu,R30
; 0000 0259                     break;
_0x83:
	RJMP _0x7C
; 0000 025A 
; 0000 025B 					default: Menu=Choix_Mode_MD23;
_0x84:
	LDI  R30,LOW(8)
_0x146:
	STS  _Menu,R30
; 0000 025C 				}
_0x7C:
; 0000 025D 
; 0000 025E 			  Menu_1 = Choix_Mode_MD23;
	LDI  R30,LOW(8)
	JMP  _0x13D
; 0000 025F 	        break;
; 0000 0260 // ==========================================================================================================================
; 0000 0261             case Reglage_Valeurs_Mode0_MD23:   if ((Menu_1 != Menu) || (SpeedMot1_1 != SpeedMot1)||(SpeedMot2_1 != SpeedMot2)
_0x76:
	CPI  R30,LOW(0x9)
	BREQ PC+3
	JMP _0x85
; 0000 0262                                                                     ||(Finesse_1 != Finesse))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x87
	__GETB1SX 236
	CP   R30,R20
	BRNE _0x87
	__GETB1SX 235
	__GETB2SX 254
	CP   R30,R26
	BRNE _0x87
	__GETB1SX 237
	CP   R30,R21
	BRNE _0x87
	RJMP _0x86
_0x87:
; 0000 0263               {
; 0000 0264                 sprintf(Buffer_for_LCD_Line0,"[200]Mode%-u (+%-u) ",Choix_Mode,Finesse);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,444
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 238
	CALL __CBD1
	CALL __PUTPARD1
	__GETB1SX 245
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 0265                 sprintf(Buffer_for_LCD_Line1,"SM1=%-u SM2=%-u",SpeedMot1,SpeedMot2);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,465
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 240
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB1SX 243
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 0266                 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0267                 Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0268                 SpeedMot1_1 = SpeedMot1; SpeedMot2_1 = SpeedMot2; Finesse_1 = Finesse;
	__GETBRSX 20,236
	__GETB1SX 235
	__PUTB1SX 254
	__GETBRSX 21,237
; 0000 0269               }
; 0000 026A 
; 0000 026B 
; 0000 026C               switch (BP_I2C)
_0x86:
	__GETB1SX 238
; 0000 026D 				{
; 0000 026E 				 	case ECHAP_I2C :  Menu=Choix_Mode_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0x8C
	LDI  R30,LOW(8)
	RJMP _0x147
; 0000 026F 
; 0000 0270 				 	case PLUS_I2C:
_0x8C:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x8D
; 0000 0271 				 		switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 0272 				 		  {
; 0000 0273 				 		   	case MoteurG: if (Finesse==1)
	CPI  R30,0
	BRNE _0x91
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0x92
; 0000 0274 				 		   					    if (SpeedMot1 < 255) SpeedMot1++; else SpeedMot1=255;
	__GETB2SX 236
	CPI  R26,LOW(0xFF)
	BRSH _0x93
	MOVW R26,R28
	SUBI R26,LOW(-(236))
	SBCI R27,HIGH(-(236))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0x94
_0x93:
	LDI  R30,LOW(255)
	__PUTB1SX 236
; 0000 0275 				 		   			      else // Finesse == 0
_0x94:
	RJMP _0x95
_0x92:
; 0000 0276 				 		   					    if (SpeedMot1 < 250) SpeedMot1+=5; else SpeedMot1=255;
	__GETB2SX 236
	CPI  R26,LOW(0xFA)
	BRSH _0x96
	__GETB1SX 236
	SUBI R30,-LOW(5)
	RJMP _0x148
_0x96:
	LDI  R30,LOW(255)
_0x148:
	__PUTB1SX 236
; 0000 0277 				 		   	break;
_0x95:
	RJMP _0x90
; 0000 0278 				 		   	case MoteurD: if (Finesse==1)
_0x91:
	CPI  R30,LOW(0x1)
	BRNE _0x90
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0x99
; 0000 0279 				 		   					    if (SpeedMot2 < 255) SpeedMot2++; else SpeedMot2=255;
	__GETB2SX 235
	CPI  R26,LOW(0xFF)
	BRSH _0x9A
	MOVW R26,R28
	SUBI R26,LOW(-(235))
	SBCI R27,HIGH(-(235))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0x9B
_0x9A:
	LDI  R30,LOW(255)
	__PUTB1SX 235
; 0000 027A 				 		   	              else // Finesse == 0
_0x9B:
	RJMP _0x9C
_0x99:
; 0000 027B 				 		   					    if (SpeedMot2 < 250) SpeedMot2+=5; else SpeedMot2=255;
	__GETB2SX 235
	CPI  R26,LOW(0xFA)
	BRSH _0x9D
	__GETB1SX 235
	SUBI R30,-LOW(5)
	RJMP _0x149
_0x9D:
	LDI  R30,LOW(255)
_0x149:
	__PUTB1SX 235
; 0000 027C 				 		   	break;
_0x9C:
; 0000 027D 				 		  }
_0x90:
; 0000 027E 				 	break;
	RJMP _0x8B
; 0000 027F 
; 0000 0280 				 	case MOINS_I2C:
_0x8D:
	CPI  R30,LOW(0x8)
	BREQ PC+3
	JMP _0x9F
; 0000 0281 				 	    switch (Choix_Moteur)
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
; 0000 0282 				 		  {
; 0000 0283 				 		   	case MoteurG: if (Finesse==1)
	CPI  R30,0
	BRNE _0xA3
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0xA4
; 0000 0284 				 		   					    if (SpeedMot1 > 0) SpeedMot1--; else SpeedMot1=0;
	__GETB2SX 236
	CPI  R26,LOW(0x1)
	BRLO _0xA5
	MOVW R26,R28
	SUBI R26,LOW(-(236))
	SBCI R27,HIGH(-(236))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0xA6
_0xA5:
	LDI  R30,LOW(0)
	__PUTB1SX 236
; 0000 0285 				 		   			      else  // Finesse == 0
_0xA6:
	RJMP _0xA7
_0xA4:
; 0000 0286 				 		   					    if (SpeedMot1 > 5) SpeedMot1-=5; else SpeedMot1=0;
	__GETB2SX 236
	CPI  R26,LOW(0x6)
	BRLO _0xA8
	__GETB1SX 236
	SUBI R30,LOW(5)
	RJMP _0x14A
_0xA8:
	LDI  R30,LOW(0)
_0x14A:
	__PUTB1SX 236
; 0000 0287 				 		   	break;
_0xA7:
	RJMP _0xA2
; 0000 0288 				 		   	case MoteurD: if (Finesse==1)
_0xA3:
	CPI  R30,LOW(0x1)
	BRNE _0xA2
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0xAB
; 0000 0289 				 		   					    if (SpeedMot2 > 0) SpeedMot2--; else SpeedMot2=0;
	__GETB2SX 235
	CPI  R26,LOW(0x1)
	BRLO _0xAC
	MOVW R26,R28
	SUBI R26,LOW(-(235))
	SBCI R27,HIGH(-(235))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0xAD
_0xAC:
	LDI  R30,LOW(0)
	__PUTB1SX 235
; 0000 028A 				 		   			      else  // Finesse == 0
_0xAD:
	RJMP _0xAE
_0xAB:
; 0000 028B 				 		   					    if (SpeedMot2 > 5) SpeedMot2-=5; else SpeedMot2=0;
	__GETB2SX 235
	CPI  R26,LOW(0x6)
	BRLO _0xAF
	__GETB1SX 235
	SUBI R30,LOW(5)
	RJMP _0x14B
_0xAF:
	LDI  R30,LOW(0)
_0x14B:
	__PUTB1SX 235
; 0000 028C 				 			break;
_0xAE:
; 0000 028D 				 		  }
_0xA2:
; 0000 028E 				 	break;
	RJMP _0x8B
; 0000 028F 
; 0000 0290 				 	case FlecheH_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0x9F:
	CPI  R30,LOW(0x2)
	BRNE _0xB1
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0xB2
	LDI  R30,LOW(5)
	RJMP _0x14C
_0xB2:
	LDI  R30,LOW(1)
_0x14C:
	__PUTB1SX 237
	RJMP _0x8B
; 0000 0291 
; 0000 0292 				 	case FlecheB_I2C: if (Finesse==1) Finesse = 5; else Finesse = 1; break;
_0xB1:
	CPI  R30,LOW(0x4)
	BRNE _0xB4
	__GETB2SX 237
	CPI  R26,LOW(0x1)
	BRNE _0xB5
	LDI  R30,LOW(5)
	RJMP _0x14D
_0xB5:
	LDI  R30,LOW(1)
_0x14D:
	__PUTB1SX 237
	RJMP _0x8B
; 0000 0293 
; 0000 0294 				 	case OK_I2C: if (Choix_Moteur == 1) Choix_Moteur=0; else Choix_Moteur=1; break;
_0xB4:
	CPI  R30,LOW(0x20)
	BRNE _0xB7
	SBRS R2,0
	RJMP _0xB8
	CLT
	RJMP _0x14E
_0xB8:
	SET
_0x14E:
	BLD  R2,0
	RJMP _0x8B
; 0000 0295 
; 0000 0296 				 	case SET_I2C:   Speed1[2] = SpeedMot1; Speed2[2] = SpeedMot2;
_0xB7:
	CPI  R30,LOW(0x10)
	BRNE _0xBB
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ADIW R30,2
	__GETB2SX 236
	STD  Z+0,R26
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ADIW R30,2
	__GETB2SX 235
	STD  Z+0,R26
; 0000 0297 				 				    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0298 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0299 				    break;
	RJMP _0x8B
; 0000 029A 
; 0000 029B 					default: Menu = Reglage_Valeurs_Mode0_MD23;
_0xBB:
	LDI  R30,LOW(9)
_0x147:
	STS  _Menu,R30
; 0000 029C 				}
_0x8B:
; 0000 029D 			  Menu_1 = Reglage_Valeurs_Mode0_MD23;
	LDI  R30,LOW(9)
	JMP  _0x13D
; 0000 029E 			break;
; 0000 029F // ==========================================================================================================================
; 0000 02A0 // Affichages associ au sous-menu "[21] Affichage ..."  (Contenu des registres de la carte MD23 ou MD25)
; 0000 02A1 // ==========================================================================================================================
; 0000 02A2 // Affichage de tous les registres de la carte MD23/MD25 (associ  "[210] Affichage registres")
; 0000 02A3 		case Info_All: Vitesse_MD23 = Table_Registers_MD23[6];
_0x85:
	CPI  R30,LOW(0xA)
	BREQ PC+3
	JMP _0xBC
	LDD  R30,Y+56
	__PUTB1SX 239
; 0000 02A4 			if ((Menu_1 != Menu)||(Num_Reg_MD23_1 != Num_Reg_MD23)||(Vitesse_MD23_1 != Vitesse_MD23))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xBE
	__GETW1SX 240
	CP   R30,R16
	CPC  R31,R17
	BRNE _0xBE
	__GETB1SX 239
	CP   R30,R19
	BRNE _0xBE
	RJMP _0xBD
_0xBE:
; 0000 02A5 			  {
; 0000 02A6 				sprintf(Buffer_for_LCD_Line0,"[210] Reg%-u= %-u",Num_Reg_MD23,Table_Registers_MD23[Num_Reg_MD23+1]) ;
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,481
	ST   -Y,R31
	ST   -Y,R30
	__GETW1SX 244
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETW1SX 248
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,58
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 02A7 				strcpyf(Buffer_for_LCD_Line1,Ligne1PlusMoins);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1PlusMoins
	LDS  R31,_Ligne1PlusMoins+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 02A8 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02A9 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 02AA 				Num_Reg_MD23_1 = Num_Reg_MD23; Vitesse_MD23_1 = Vitesse_MD23;
	__GETWRSX 16,17,240
	__GETBRSX 19,239
; 0000 02AB 			  }
; 0000 02AC 
; 0000 02AD 			switch (BP_I2C)
_0xBD:
	__GETB1SX 238
; 0000 02AE 				{
; 0000 02AF 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xC3
	LDI  R30,LOW(5)
	RJMP _0x14F
; 0000 02B0 					case PLUS_I2C: if (Num_Reg_MD23<16) Num_Reg_MD23++; else Num_Reg_MD23=0;  break;
_0xC3:
	CPI  R30,LOW(0x1)
	BRNE _0xC4
	__GETW2SX 240
	SBIW R26,16
	BRSH _0xC5
	MOVW R26,R28
	SUBI R26,LOW(-(240))
	SBCI R27,HIGH(-(240))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0xC6
_0xC5:
	LDI  R30,LOW(0)
	__CLRW1SX 240
_0xC6:
	RJMP _0xC2
; 0000 02B1 					case MOINS_I2C: if (Num_Reg_MD23>0) Num_Reg_MD23--; else Num_Reg_MD23=16;  break;
_0xC4:
	CPI  R30,LOW(0x8)
	BRNE _0xC7
	__GETW2SX 240
	CALL __CPW02
	BRSH _0xC8
	MOVW R26,R28
	SUBI R26,LOW(-(240))
	SBCI R27,HIGH(-(240))
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RJMP _0xC9
_0xC8:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	__PUTW1SX 240
_0xC9:
	RJMP _0xC2
; 0000 02B2 					case FlecheH_I2C: Menu = Info_TensionBatt;  break;
_0xC7:
	CPI  R30,LOW(0x2)
	BRNE _0xCA
	LDI  R30,LOW(12)
	RJMP _0x14F
; 0000 02B3 					case FlecheB_I2C: Menu = Info_Version;  break;
_0xCA:
	CPI  R30,LOW(0x4)
	BRNE _0xCC
	LDI  R30,LOW(11)
	RJMP _0x14F
; 0000 02B4 					default: Menu=Info_All;
_0xCC:
	LDI  R30,LOW(10)
_0x14F:
	STS  _Menu,R30
; 0000 02B5 				}
_0xC2:
; 0000 02B6 
; 0000 02B7 			Menu_1 = Info_All;
	LDI  R30,LOW(10)
	JMP  _0x13D
; 0000 02B8 		break;
; 0000 02B9 // ==========================================================================================================================
; 0000 02BA // Affichage de la version du logiciel implant dans la carte MD23 ou MD25 (associ  "[211] Affichage version soft")
; 0000 02BB // ==========================================================================================================================
; 0000 02BC 		case Info_Version:	Version = Table_Registers_MD23[14];
_0xBC:
	CPI  R30,LOW(0xB)
	BREQ PC+3
	JMP _0xCD
	__GETB1SX 64
	__PUTB1SX 232
; 0000 02BD 			if ((Menu_1 != Menu)||(Version_1 != Version))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xCF
	__GETB1SX 232
	__GETB2SX 251
	CP   R30,R26
	BREQ _0xCE
_0xCF:
; 0000 02BE    			  {
; 0000 02BF 				sprintf(Buffer_for_LCD_Line0,"[211] Vers.=%-u  ",Version);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,499
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 236
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 02C0 				strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 02C1 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02C2 				Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 02C3 				Version_1 = Version;
	__GETB1SX 232
	__PUTB1SX 251
; 0000 02C4 			  }
; 0000 02C5 
; 0000 02C6 			switch (BP_I2C)
_0xCE:
	__GETB1SX 238
; 0000 02C7 				{
; 0000 02C8 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xD4
	LDI  R30,LOW(5)
	RJMP _0x150
; 0000 02C9 					case FlecheH_I2C: Menu = Info_All;  break;
_0xD4:
	CPI  R30,LOW(0x2)
	BRNE _0xD5
	LDI  R30,LOW(10)
	RJMP _0x150
; 0000 02CA 					case FlecheB_I2C: Menu = Info_TensionBatt;  break;
_0xD5:
	CPI  R30,LOW(0x4)
	BRNE _0xD7
	LDI  R30,LOW(12)
	RJMP _0x150
; 0000 02CB 					default: Menu=Info_Version;
_0xD7:
	LDI  R30,LOW(11)
_0x150:
	STS  _Menu,R30
; 0000 02CC 				}
; 0000 02CD 
; 0000 02CE 			Menu_1 = Info_Version;
	LDI  R30,LOW(11)
	JMP  _0x13D
; 0000 02CF 		break;
; 0000 02D0 // ==========================================================================================================================
; 0000 02D1 // Affichage de la tension d'alimentation de la carte MD23 ou MD25  (associ  "[212] Affichage tension batterie")
; 0000 02D2 // ==========================================================================================================================
; 0000 02D3 		case Info_TensionBatt:  	Ubatt = Table_Registers_MD23[11];
_0xCD:
	CPI  R30,LOW(0xC)
	BREQ PC+3
	JMP _0xD8
	LDD  R30,Y+61
	__PUTB1SX 233
; 0000 02D4 			if ((Menu_1 != Menu)||(Ubatt_1 != Ubatt))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xDA
	__GETB1SX 233
	__GETB2SX 252
	CP   R30,R26
	BRNE _0xDA
	RJMP _0xD9
_0xDA:
; 0000 02D5    			  {
; 0000 02D6 					sprintf(Buffer_for_LCD_Line0,"[212]Ubat=%-u.%-uV ",Ubatt/10, Ubatt-10*(Ubatt/10));
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,517
	ST   -Y,R31
	ST   -Y,R30
	__GETB2SX 237
	LDI  R30,LOW(10)
	CALL __DIVB21U
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB2SX 241
	LDI  R30,LOW(10)
	CALL __DIVB21U
	LDI  R26,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	__GETB2SX 241
	CALL __SWAPB12
	SUB  R30,R26
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 02D7 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchap);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap
	LDS  R31,_Ligne1ChoixEchap+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 02D8 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02D9                     Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 02DA                     Ubatt_1 = Ubatt;
	__GETB1SX 233
	__PUTB1SX 252
; 0000 02DB 			  }
; 0000 02DC 
; 0000 02DD 			switch (BP_I2C)
_0xD9:
	__GETB1SX 238
; 0000 02DE 				{
; 0000 02DF 					case ECHAP_I2C : Menu=Menu21_Infos_MD23; break;
	CPI  R30,LOW(0x80)
	BRNE _0xDF
	LDI  R30,LOW(5)
	RJMP _0x151
; 0000 02E0 					case FlecheH_I2C: Menu = Info_Version;  break;
_0xDF:
	CPI  R30,LOW(0x2)
	BRNE _0xE0
	LDI  R30,LOW(11)
	RJMP _0x151
; 0000 02E1 					case FlecheB_I2C: Menu = Info_All;  break;
_0xE0:
	CPI  R30,LOW(0x4)
	BRNE _0xE2
	LDI  R30,LOW(10)
	RJMP _0x151
; 0000 02E2 					default: Menu=Info_TensionBatt;
_0xE2:
	LDI  R30,LOW(12)
_0x151:
	STS  _Menu,R30
; 0000 02E3 				}
; 0000 02E4 
; 0000 02E5 			Menu_1 = Info_TensionBatt;
	LDI  R30,LOW(12)
	RJMP _0x13D
; 0000 02E6 		break;
; 0000 02E7 // ==========================================================================================================================
; 0000 02E8 // Slection d'un type de dplacement associ au sous-menu "[22] Choix dplacement"(La premire slection est "Ligne droite")
; 0000 02E9 // ==========================================================================================================================
; 0000 02EA 		case Selection_Deplacements:
_0xD8:
	CPI  R30,LOW(0xD)
	BREQ PC+3
	JMP _0xE3
; 0000 02EB 			if ((Menu_1 != Menu)||(SelecDeplacement_1 != SelecDeplacement))
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0xE5
	__GETB1SX 218
	__GETB2SX 242
	CP   R30,R26
	BRNE _0xE5
	RJMP _0xE4
_0xE5:
; 0000 02EC    			  {
; 0000 02ED                     switch (SelecDeplacement)
	__GETB1SX 218
; 0000 02EE                     {
; 0000 02EF 					    case 0: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droit "); break;
	CPI  R30,0
	BREQ _0x152
; 0000 02F0                         case 1: sprintf(Buffer_for_LCD_Line0,"[221]Virage G90 "); break;
	CPI  R30,LOW(0x1)
	BRNE _0xEB
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,554
	RJMP _0x153
; 0000 02F1                         case 2: sprintf(Buffer_for_LCD_Line0,"[222]Vira. G180 "); break;
_0xEB:
	CPI  R30,LOW(0x2)
	BRNE _0xEC
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,571
	RJMP _0x153
; 0000 02F2                         case 3: sprintf(Buffer_for_LCD_Line0,"[223]Virage D90 "); break;
_0xEC:
	CPI  R30,LOW(0x3)
	BRNE _0xED
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,588
	RJMP _0x153
; 0000 02F3                         case 4: sprintf(Buffer_for_LCD_Line0,"[224]Vira. D180 "); break;
_0xED:
	CPI  R30,LOW(0x4)
	BRNE _0xEE
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,605
	RJMP _0x153
; 0000 02F4                         case 5: sprintf(Buffer_for_LCD_Line0,"[225]Bala. Zone "); break;
_0xEE:
	CPI  R30,LOW(0x5)
	BRNE _0xEF
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,622
	RJMP _0x153
; 0000 02F5                         case 6: sprintf(Buffer_for_LCD_Line0,"[226]Orien. Sud "); break;
_0xEF:
	CPI  R30,LOW(0x6)
	BRNE _0xF1
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,639
	RJMP _0x153
; 0000 02F6                         default: sprintf(Buffer_for_LCD_Line0,"[220]Lig. droit ");
_0xF1:
_0x152:
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,537
_0x153:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02F7                     }
; 0000 02F8 					strcpyf(Buffer_for_LCD_Line1,Ligne1ChoixEchapSET);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchapSET
	LDS  R31,_Ligne1ChoixEchapSET+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 02F9 					Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 02FA                     Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 02FB                     SelecDeplacement_1 = SelecDeplacement;
	__GETB1SX 218
	__PUTB1SX 242
; 0000 02FC 			  }
; 0000 02FD 
; 0000 02FE 			switch (BP_I2C)
_0xE4:
	__GETB1SX 238
; 0000 02FF 				{
; 0000 0300 					case ECHAP_I2C : Menu = Menu22_Deplacements; break;
	CPI  R30,LOW(0x80)
	BRNE _0xF5
	LDI  R30,LOW(6)
	RJMP _0x154
; 0000 0301 					case FlecheH_I2C: if (SelecDeplacement > 0) SelecDeplacement--; else SelecDeplacement=6;  break;
_0xF5:
	CPI  R30,LOW(0x2)
	BRNE _0xF6
	__GETB2SX 218
	CPI  R26,LOW(0x1)
	BRLO _0xF7
	MOVW R26,R28
	SUBI R26,LOW(-(218))
	SBCI R27,HIGH(-(218))
	LD   R30,X
	SUBI R30,LOW(1)
	ST   X,R30
	RJMP _0xF8
_0xF7:
	LDI  R30,LOW(6)
	__PUTB1SX 218
_0xF8:
	RJMP _0xF4
; 0000 0302 					case FlecheB_I2C: if (SelecDeplacement < 6) SelecDeplacement++; else SelecDeplacement=0;  break;
_0xF6:
	CPI  R30,LOW(0x4)
	BRNE _0xF9
	__GETB2SX 218
	CPI  R26,LOW(0x6)
	BRSH _0xFA
	MOVW R26,R28
	SUBI R26,LOW(-(218))
	SBCI R27,HIGH(-(218))
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RJMP _0xFB
_0xFA:
	LDI  R30,LOW(0)
	__PUTB1SX 218
_0xFB:
	RJMP _0xF4
; 0000 0303                     case SET_I2C:
_0xF9:
	CPI  R30,LOW(0x10)
	BREQ PC+3
	JMP _0x109
; 0000 0304                         switch (SelecDeplacement) // Rglage des vitesses (sera remplac par l'appel d'une fonction)
	__GETB1SX 218
; 0000 0305                           { // Seul le Mode 0 est gr !!!!!!!!!!!!!!!!!
; 0000 0306                             // Paramtrage du test slectionn
; 0000 0307                             // Exemple calcul avec fichier xls
; 0000 0308                             // Consigne vitesse moyenne  = 20cm/s, Distance de la ligne droite = 1m,
; 0000 0309                             // Rayon du virage = 23 cm
; 0000 030A                             // Remarque: Slectionner le codeur correspondant  la plus grande valeur de Speed
; 0000 030B                             // Sur le robot:
; 0000 030C                             // Speed1 = Registre vitesse moteur G - Speed 2 = Registre vitesse moteur D
; 0000 030D                             // Numero codeur = 0 pour l'encodeur 1 (gauche) et Numero codeur = 1 pour l'encodeur 2 (droit)
; 0000 030E                             case 0: Speed1[2] = 151; Speed2[2] = 151; Valeur_Codeur_Stop = 1156; NumeroCodeur = 0;  break;  // Dplacement en ligne droite
	CPI  R30,0
	BRNE _0x100
	LDI  R30,LOW(151)
	__PUTB1SX 275
	__PUTB1SX 272
	__GETD1N 0x484
	__PUTD1SX 220
	LDI  R30,LOW(0)
	__PUTB1SX 219
	RJMP _0xFF
; 0000 030F                             case 1: Speed1[2] = 128; Speed2[2] = 173; Valeur_Codeur_Stop = 828; NumeroCodeur = 1; break;    // Virage  90  G
_0x100:
	CPI  R30,LOW(0x1)
	BRNE _0x101
	LDI  R30,LOW(128)
	__PUTB1SX 275
	LDI  R30,LOW(173)
	__PUTB1SX 272
	__GETD1N 0x33C
	__PUTD1SX 220
	LDI  R30,LOW(1)
	__PUTB1SX 219
	RJMP _0xFF
; 0000 0310                             case 2: Speed1[2] = 128; Speed2[2] = 173; Valeur_Codeur_Stop = 1656; NumeroCodeur = 1; break;   // Virage  180  G
_0x101:
	CPI  R30,LOW(0x2)
	BRNE _0x102
	LDI  R30,LOW(128)
	__PUTB1SX 275
	LDI  R30,LOW(173)
	__PUTB1SX 272
	__GETD1N 0x678
	__PUTD1SX 220
	LDI  R30,LOW(1)
	__PUTB1SX 219
	RJMP _0xFF
; 0000 0311                             case 3: Speed1[2] = 173; Speed2[2] = 128; Valeur_Codeur_Stop = 828; NumeroCodeur = 0; break;    // Virage  90  D
_0x102:
	CPI  R30,LOW(0x3)
	BRNE _0x103
	LDI  R30,LOW(173)
	__PUTB1SX 275
	LDI  R30,LOW(128)
	__PUTB1SX 272
	__GETD1N 0x33C
	__PUTD1SX 220
	LDI  R30,LOW(0)
	__PUTB1SX 219
	RJMP _0xFF
; 0000 0312                             case 4: Speed1[2] = 173; Speed2[2] = 128; Valeur_Codeur_Stop = 1656; NumeroCodeur = 0; break;   // Virage  180  D
_0x103:
	CPI  R30,LOW(0x4)
	BRNE _0x104
	LDI  R30,LOW(173)
	__PUTB1SX 275
	LDI  R30,LOW(128)
	__PUTB1SX 272
	__GETD1N 0x678
	__PUTD1SX 220
	LDI  R30,LOW(0)
	__PUTB1SX 219
	RJMP _0xFF
; 0000 0313                             case 5: // Balayage
_0x104:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x105
; 0000 0314                                     // Initialisation
; 0000 0315                                     Direction_MSB = 0; Direction_LSB = 0; AngleEnDegreFoisDix = 0;
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+7,R30
	STD  Y+5,R30
	STD  Y+5+1,R30
; 0000 0316                                     i = 0; // Initialisation du premier mouvement stock dans TableBalayage
	STD  Y+11,R30
	STD  Y+11+1,R30
; 0000 0317                                     delay_ms(3000); // Attente avant le dpart et reset des encodeurs au cas ou on dplace
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0318                                     // le robot avant de partir
; 0000 0319                                     TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(279))
	SBCI R31,HIGH(-(279))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 031A                                     Speed1[2] = Table_Balayage[i][0]; Speed2[2] = Table_Balayage[i][1];
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ADIW R30,2
	MOVW R0,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ADIW R30,2
	MOVW R0,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	MOVW R26,R0
	ST   X,R30
; 0000 031B                                     Valeur_Codeur_Stop = Table_Balayage[i][2]; NumeroCodeur = Table_Balayage[i][3];
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
	__PUTD1SX 220
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+6
	__PUTB1SX 219
; 0000 031C                                     TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 031D 									TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 031E                                     Menu = Balayage;
	LDI  R30,LOW(15)
	STS  _Menu,R30
; 0000 031F                             break;
	RJMP _0xFF
; 0000 0320                             case 6:    delay_ms(3000); Menu = Orientation_Sud; break;
_0x105:
	CPI  R30,LOW(0x6)
	BRNE _0x107
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(16)
	STS  _Menu,R30
	RJMP _0xFF
; 0000 0321                             default :  Speed1[2] = 128; Speed2[2] = 128;           // Arrt des moteurs en mode 0
_0x107:
	LDI  R30,LOW(128)
	__PUTB1SX 275
	__PUTB1SX 272
; 0000 0322                           }
_0xFF:
; 0000 0323 
; 0000 0324                             if (SelecDeplacement < 5)
	__GETB2SX 218
	CPI  R26,LOW(0x5)
	BRSH _0x108
; 0000 0325                                 {
; 0000 0326                                     delay_ms(3000); // Attente avant le dpart et reset des encodeurs au cas ou on dplace
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0327                                     // le robot avant de partir
; 0000 0328                                     TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(279))
	SBCI R31,HIGH(-(279))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0329                                     TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 032A 								    TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 032B                                     Menu = Test_Deplacements_Elementaires;
	LDI  R30,LOW(14)
	STS  _Menu,R30
; 0000 032C                                 }
; 0000 032D 
; 0000 032E                     break;
_0x108:
	RJMP _0xF4
; 0000 032F 					default: Menu = Selection_Deplacements;
_0x109:
	LDI  R30,LOW(13)
_0x154:
	STS  _Menu,R30
; 0000 0330 				}
_0xF4:
; 0000 0331 
; 0000 0332 			Menu_1 = Selection_Deplacements;
	LDI  R30,LOW(13)
	RJMP _0x13D
; 0000 0333 		break;
; 0000 0334 // ==========================================================================================================================
; 0000 0335 // Gestion d'un dplacement lmentaire(associ  "[220] Dplacement ligne droite" ou "[221] Virage 90" ou [222] Virage 180)
; 0000 0336 // ==========================================================================================================================
; 0000 0337 		case Test_Deplacements_Elementaires:
_0xE3:
	CPI  R30,LOW(0xE)
	BREQ PC+3
	JMP _0x10A
; 0000 0338             // Calcul du dplacement en nombre de priodes du codeur
; 0000 0339             TableCodeur[0] = (long int)65536*Table_Registers_MD23[4] + (long int)256*Table_Registers_MD23[5] + Table_Registers_MD23[6];
	LDD  R30,Y+54
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+55
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+56
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__PUTD1SX 224
; 0000 033A             TableCodeur[1] = (long int)65536*Table_Registers_MD23[8] + (long int)256*Table_Registers_MD23[9] + Table_Registers_MD23[10];
	MOVW R30,R28
	SUBI R30,LOW(-(224))
	SBCI R31,HIGH(-(224))
	ADIW R30,4
	PUSH R31
	PUSH R30
	LDD  R30,Y+58
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+59
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+60
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	POP  R26
	POP  R27
	CALL __PUTDP1
; 0000 033B 
; 0000 033C                                                                         // Test si la distance prvue a t parcourue
; 0000 033D             if (TableCodeur[NumeroCodeur] >= Valeur_Codeur_Stop)
	__GETB1SX 219
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(224))
	SBCI R27,HIGH(-(224))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1SX 220
	CALL __CPD21
	BRLT _0x10B
; 0000 033E              {
; 0000 033F                 Speed1[2] = 128; Speed2[2] = 128;  // Arrt
	LDI  R30,LOW(128)
	__PUTB1SX 275
	__PUTB1SX 272
; 0000 0340 			    TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0341 			    TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0342              }
; 0000 0343                                                                         // Affichage pour visualisation sur le banc Moteurs
; 0000 0344             else  if ((Menu_1 != Menu) || (TableCodeur_1[NumeroCodeur] != TableCodeur[NumeroCodeur]))
	RJMP _0x10C
_0x10B:
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BRNE _0x10E
	__GETB1SX 219
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(243))
	SBCI R27,HIGH(-(243))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETB1SX 219
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(224))
	SBCI R27,HIGH(-(224))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CPD12
	BRNE _0x10E
	RJMP _0x10D
_0x10E:
; 0000 0345 
; 0000 0346    			             {
; 0000 0347                             ltoa(TableCodeur[0], AfficheDeplacement1); // Conversion du dplacement en une chane de
	__GETD1SX 224
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 0348                             ltoa(TableCodeur[1], AfficheDeplacement2); // caractres avant affichage sur le LCD
	__GETD1SX 228
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(72))
	SBCI R31,HIGH(-(72))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 0349                             strcpy(Buffer_for_LCD_Line0,"Enc1=");
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0x110,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpy
; 0000 034A                             strcat(Buffer_for_LCD_Line0, AfficheDeplacement1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(81))
	SBCI R31,HIGH(-(81))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 034B 					        strcpyf(Buffer_for_LCD_Line1,"Enc2=");
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,662
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 034C                             strcat(Buffer_for_LCD_Line1, AfficheDeplacement2);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 034D                             strcat(Buffer_for_LCD_Line1," [Echa]");
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0x110,6
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 034E 					        Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 034F                             TableCodeur_1[NumeroCodeur] = TableCodeur[NumeroCodeur];
	__GETB1SX 219
	LDI  R31,0
	MOVW R22,R30
	MOVW R26,R28
	SUBI R26,LOW(-(243))
	SBCI R27,HIGH(-(243))
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R22
	MOVW R26,R28
	SUBI R26,LOW(-(224))
	SBCI R27,HIGH(-(224))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R0
	CALL __PUTDP1
; 0000 0350 			             }
; 0000 0351 
; 0000 0352 			switch (BP_I2C)
_0x10D:
_0x10C:
	__GETB1SX 238
; 0000 0353 				  {
; 0000 0354 					case ECHAP_I2C : Menu = Selection_Deplacements;
	CPI  R30,LOW(0x80)
	BRNE _0x115
	LDI  R30,LOW(13)
	STS  _Menu,R30
; 0000 0355                                      Speed1[2] = 128; Speed2[2] = 128;   // Arrt des moteurs
	LDI  R30,LOW(128)
	__PUTB1SX 275
	__PUTB1SX 272
; 0000 0356 				                     TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0357 				                     TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0358                                      delay_ms(500); // Arrt complet des moteurs !
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0359                                      // Remise  zro des encodeurs
; 0000 035A                                      TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23));
	MOVW R30,R28
	SUBI R30,LOW(-(279))
	SBCI R31,HIGH(-(279))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 035B                     break;
	RJMP _0x113
; 0000 035C 					default: Menu = Test_Deplacements_Elementaires;
_0x115:
	LDI  R30,LOW(14)
	STS  _Menu,R30
; 0000 035D 				  }
_0x113:
; 0000 035E 
; 0000 035F 			Menu_1 = Test_Deplacements_Elementaires;
	LDI  R30,LOW(14)
	RJMP _0x13D
; 0000 0360 		break;
; 0000 0361 // ==========================================================================================================================
; 0000 0362 // Gestion du balayage d'une zone de 16m et orientation associ  "[223] Balayage Zone"
; 0000 0363 // ==========================================================================================================================
; 0000 0364         case Balayage:
_0x10A:
	CPI  R30,LOW(0xF)
	BREQ PC+3
	JMP _0x116
; 0000 0365 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0366         // Squence de dplacement
; 0000 0367 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0368          for (i = 0 ; i <  Nombre_Deplacements_du_Balayage - 1;i++)
	LDI  R30,LOW(0)
	STD  Y+11,R30
	STD  Y+11+1,R30
_0x118:
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	SBIW R26,15
	BRLO PC+3
	JMP _0x119
; 0000 0369           {
; 0000 036A            do
_0x11B:
; 0000 036B            {
; 0000 036C // --------------------------------------------------------------------------------------------------------------------------
; 0000 036D             // Lecture des codeurs
; 0000 036E // --------------------------------------------------------------------------------------------------------------------------
; 0000 036F             // Envoi de l'octet d'adresse MD23 + bit RW=criture + n du Reg
; 0000 0370 	            TWI_Start_Transc_With_Data(Read_Reg_MD23_W,sizeof(Read_Reg_MD23_W));
	MOVW R30,R28
	SUBI R30,LOW(-(265))
	SBCI R31,HIGH(-(265))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0371    	            TWI_Start_Transc_With_Data(Table_Registers_MD23,18);  		// Envoi octet d'adresse MD23 +  bit RW=lecture
	MOVW R30,R28
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0372 	            TWI_Get_Data_From_Transceiver(Table_Registers_MD23,sizeof(Table_Registers_MD23));
	MOVW R30,R28
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 0373 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0374             // Calcul du dplacement en nombre de priodes du codeur
; 0000 0375 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0376             TableCodeur[0] = (long int)65536*Table_Registers_MD23[4] + (long int)256*Table_Registers_MD23[5] + Table_Registers_MD23[6];
	LDD  R30,Y+54
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+55
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+56
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	__PUTD1SX 224
; 0000 0377             TableCodeur[1] = (long int)65536*Table_Registers_MD23[8] + (long int)256*Table_Registers_MD23[9] + Table_Registers_MD23[10];
	MOVW R30,R28
	SUBI R30,LOW(-(224))
	SBCI R31,HIGH(-(224))
	ADIW R30,4
	PUSH R31
	PUSH R30
	LDD  R30,Y+58
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x10000
	CALL __MULD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+59
	CLR  R31
	CLR  R22
	CLR  R23
	__GETD2N 0x100
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD21
	LDD  R30,Y+60
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ADDD12
	POP  R26
	POP  R27
	CALL __PUTDP1
; 0000 0378 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0379              ltoa(TableCodeur[0], AfficheDeplacement1);                      // Conversion du dplacement en une chane de
	__GETD1SX 224
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(83))
	SBCI R31,HIGH(-(83))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 037A              ltoa(TableCodeur[1], AfficheDeplacement2);                      // caractres avant affichage sur le LCD
	__GETD1SX 228
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(72))
	SBCI R31,HIGH(-(72))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 037B              strcpy(Buffer_for_LCD_Line0,"Enc1=");
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0x110,14
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpy
; 0000 037C              strcat(Buffer_for_LCD_Line0, AfficheDeplacement1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(81))
	SBCI R31,HIGH(-(81))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 037D 			 strcpyf(Buffer_for_LCD_Line1,"Enc2=");
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,662
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
; 0000 037E              strcat(Buffer_for_LCD_Line1, AfficheDeplacement2);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 037F              strcat(Buffer_for_LCD_Line1," [Echa]");
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _0x110,20
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcat
; 0000 0380 			 Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0381              TableCodeur_1[NumeroCodeur] = TableCodeur[NumeroCodeur];
	__GETB1SX 219
	LDI  R31,0
	MOVW R22,R30
	MOVW R26,R28
	SUBI R26,LOW(-(243))
	SBCI R27,HIGH(-(243))
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	MOVW R30,R22
	MOVW R26,R28
	SUBI R26,LOW(-(224))
	SBCI R27,HIGH(-(224))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R0
	CALL __PUTDP1
; 0000 0382            }
; 0000 0383             while (TableCodeur[NumeroCodeur] <= Valeur_Codeur_Stop);        // Fin Dplacement(i)
	__GETB1SX 219
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(224))
	SBCI R27,HIGH(-(224))
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1SX 220
	CALL __CPD12
	BRLT _0x11C
	RJMP _0x11B
_0x11C:
; 0000 0384 
; 0000 0385 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0386             //Speed1[2] = 128; Speed2[2] = 128;                               // Initialisation Dplacement i + 1
; 0000 0387 			//TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
; 0000 0388 			//TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
; 0000 0389             //delay_ms(500);
; 0000 038A             // Initialisation du  nouveau dplacement -> transfert des vitesses vers la carte moteur -> Reset codeur et
; 0000 038B             // Attente avant de returner dans la boucle
; 0000 038C             Speed1[2] = Table_Balayage[i+1][0]; Speed2[2] = Table_Balayage[i+1][1]; // Initialisation Dplacement i + 1
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ADIW R30,2
	MOVW R0,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ADIW R30,2
	MOVW R0,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+2
	MOVW R26,R0
	ST   X,R30
; 0000 038D             Valeur_Codeur_Stop = Table_Balayage[i+1][2]; NumeroCodeur = Table_Balayage[i+1][3];
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R26,R30
	ADC  R27,R31
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
	__PUTD1SX 220
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	CALL __LSLW3
	MOVW R26,R28
	SUBI R26,LOW(-(90))
	SBCI R27,HIGH(-(90))
	ADD  R30,R26
	ADC  R31,R27
	LDD  R30,Z+6
	__PUTB1SX 219
; 0000 038E 			TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));    // Transfert
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 038F 			TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0390             TWI_Start_Transc_With_Data(Reset_Encodeurs_MD23,sizeof(Reset_Encodeurs_MD23)); // Reset encodeurs
	MOVW R30,R28
	SUBI R30,LOW(-(279))
	SBCI R31,HIGH(-(279))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0391             delay_ms(500); // Evite perturbation sur les roues lors des changement de vitesse
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0392             }
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	STD  Y+11,R30
	STD  Y+11+1,R31
	RJMP _0x118
_0x119:
; 0000 0393 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0394 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0395          // Orientation au sud
; 0000 0396 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0397          // Attente avant positionnement au sud
; 0000 0398              delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0399              Menu = Orientation_Sud;
	LDI  R30,LOW(16)
	STS  _Menu,R30
; 0000 039A // --------------------------------------------------------------------------------------------------------------------------
; 0000 039B 		 Menu_1 = Balayage;
	LDI  R30,LOW(15)
	RJMP _0x13D
; 0000 039C 		break;
; 0000 039D // ==========================================================================================================================
; 0000 039E // Orientation du panneau au sud
; 0000 039F // ==========================================================================================================================
; 0000 03A0 		case Orientation_Sud:
_0x116:
	CPI  R30,LOW(0x10)
	BREQ PC+3
	JMP _0x11D
; 0000 03A1 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03A2             // Lecture de la boussole HMC6352 pour connaitre la position initiale du robot
; 0000 03A3 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03A4             // Ecriture de la commande 'A'
; 0000 03A5             TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(258))
	SBCI R31,HIGH(-(258))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03A6             delay_ms(10); // time delay constructeur
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 03A7             // Lecture des octets MSB et LSB
; 0000 03A8             TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03A9             TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 03AA             Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];
	__GETB1SX 256
	STD  Y+8,R30
	__GETB1SX 257
	STD  Y+7,R30
; 0000 03AB // --------------------------------------------------------------------------------------------------------------------------
; 0000 03AC             //  Traitement (choix du sens de dplacement
; 0000 03AD // --------------------------------------------------------------------------------------------------------------------------
; 0000 03AE             // Calcul de l'angle
; 0000 03AF             AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);
	LDD  R30,Y+8
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	CALL _MSLSBYTEtoUINT
	STD  Y+5,R30
	STD  Y+5+1,R31
; 0000 03B0 
; 0000 03B1             // Configuration des registres des moteurs
; 0000 03B2             if (AngleEnDegreFoisDix > 1800)
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CPI  R26,LOW(0x709)
	LDI  R30,HIGH(0x709)
	CPC  R27,R30
	BRLO _0x11E
; 0000 03B3                 {
; 0000 03B4                  Speed1[2] = 139; Speed2[2] = 117;  // Rotation anti-horaire
	LDI  R30,LOW(139)
	__PUTB1SX 275
	LDI  R30,LOW(117)
	RJMP _0x155
; 0000 03B5                 }
; 0000 03B6             else
_0x11E:
; 0000 03B7                 {
; 0000 03B8                  Speed1[2] = 117; Speed2[2] = 139; // Rotation horaire
	LDI  R30,LOW(117)
	__PUTB1SX 275
	LDI  R30,LOW(139)
_0x155:
	__PUTB1SX 272
; 0000 03B9                 }
; 0000 03BA             TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03BB 		    TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03BC // --------------------------------------------------------------------------------------------------------------------------
; 0000 03BD             // Affichage du rsultat
; 0000 03BE // --------------------------------------------------------------------------------------------------------------------------
; 0000 03BF             do
_0x121:
; 0000 03C0               {
; 0000 03C1                 // Ecriture sur le lcd
; 0000 03C2                 itoa(AngleEnDegreFoisDix,AfficheAngle);
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 03C3                 if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB))
	LDD  R30,Y+8
	LDD  R26,Y+10
	CP   R30,R26
	BRNE _0x124
	LDD  R30,Y+7
	LDD  R26,Y+9
	CP   R30,R26
	BREQ _0x123
_0x124:
; 0000 03C4                     {	// Affichage des deux octets
; 0000 03C5 	                    sprintf(Buffer_for_LCD_Line0,"MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,676
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+15
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 03C6 	                    Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,AfficheAngle); // Affichage de l'angle
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 03C7 	                    Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 03C8 	                    Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
	LDD  R30,Y+8
	STD  Y+10,R30
	LDD  R30,Y+7
	STD  Y+9,R30
; 0000 03C9                     }
; 0000 03CA // --------------------------------------------------------------------------------------------------------------------------
; 0000 03CB                 // Lecture de la boussole HMC6352 pour connaitre la position initiale du robot
; 0000 03CC // --------------------------------------------------------------------------------------------------------------------------
; 0000 03CD                 // Ecriture de la commande 'A'
; 0000 03CE                 TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352));
_0x123:
	MOVW R30,R28
	SUBI R30,LOW(-(258))
	SBCI R31,HIGH(-(258))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03CF                 delay_ms(10); // time delay constructeur
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 03D0                 // Lecture des octets MSB et LSB
; 0000 03D1                 TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03D2                 TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 03D3                 Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];
	__GETB1SX 256
	STD  Y+8,R30
	__GETB1SX 257
	STD  Y+7,R30
; 0000 03D4                 // Calcul de l'angle
; 0000 03D5                 AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);
	LDD  R30,Y+8
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	CALL _MSLSBYTEtoUINT
	STD  Y+5,R30
	STD  Y+5+1,R31
; 0000 03D6                 // Communication avec la carte MD23 (sinon arrt au bout de 2s lorsque la scurit est active
; 0000 03D7                 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03D8 		        TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03D9               }
; 0000 03DA              while (( AngleEnDegreFoisDix < 3550) && ( AngleEnDegreFoisDix > 50));
	LDD  R26,Y+5
	LDD  R27,Y+5+1
	CPI  R26,LOW(0xDDE)
	LDI  R30,HIGH(0xDDE)
	CPC  R27,R30
	BRSH _0x126
	SBIW R26,51
	BRSH _0x127
_0x126:
	RJMP _0x122
_0x127:
	RJMP _0x121
_0x122:
; 0000 03DB // --------------------------------------------------------------------------------------------------------------------------
; 0000 03DC              // Arrt des moteurs
; 0000 03DD              Speed1[2] = 128; Speed2[2] = 128;
	LDI  R30,LOW(128)
	__PUTB1SX 275
	__PUTB1SX 272
; 0000 03DE 			 TWI_Start_Transc_With_Data(Speed1,sizeof(Speed1));
	MOVW R30,R28
	SUBI R30,LOW(-(273))
	SBCI R31,HIGH(-(273))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03DF 			 TWI_Start_Transc_With_Data(Speed2,sizeof(Speed2));
	MOVW R30,R28
	SUBI R30,LOW(-(270))
	SBCI R31,HIGH(-(270))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03E0              delay_ms(1000); // Arrt complet des moteurs !
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 03E1              Menu = Test_HMC6352;  // Pour conserver l'affichage de l'orientation du robot
	LDI  R30,LOW(17)
	STS  _Menu,R30
; 0000 03E2 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03E3 			Menu_1 = Orientation_Sud ;
	LDI  R30,LOW(16)
	RJMP _0x13D
; 0000 03E4        break;
; 0000 03E5 // ==========================================================================================================================
; 0000 03E6 // Test de la boussole
; 0000 03E7 // ==========================================================================================================================
; 0000 03E8        case Test_HMC6352 :
_0x11D:
	CPI  R30,LOW(0x11)
	BREQ PC+3
	JMP _0x128
; 0000 03E9 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03EA             // Lecture de la boussole HMC6352
; 0000 03EB // --------------------------------------------------------------------------------------------------------------------------
; 0000 03EC             // Ecriture de la commande 'A'
; 0000 03ED             TWI_Start_Transc_With_Data(Frame_I2C_Write_Command_HMC6352, sizeof(Frame_I2C_Write_Command_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(258))
	SBCI R31,HIGH(-(258))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03EE             delay_ms(10); // time delay constructeur
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 03EF             // Lecture des octets MSB et LSB
; 0000 03F0             TWI_Start_Transc_With_Data(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 03F1             TWI_Get_Data_From_Transceiver(Frame_I2C_Read_Data_HMC6352,sizeof(Frame_I2C_Read_Data_HMC6352));
	MOVW R30,R28
	SUBI R30,LOW(-(255))
	SBCI R31,HIGH(-(255))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _TWI_Get_Data_From_Transceiver
; 0000 03F2             Direction_MSB = Frame_I2C_Read_Data_HMC6352[1]; Direction_LSB = Frame_I2C_Read_Data_HMC6352[2];
	__GETB1SX 256
	STD  Y+8,R30
	__GETB1SX 257
	STD  Y+7,R30
; 0000 03F3 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03F4             // Traitement
; 0000 03F5 // --------------------------------------------------------------------------------------------------------------------------
; 0000 03F6             // Inversion de l'tat logique des BP pour affichage sur les leds
; 0000 03F7             Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1];
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 302
	COM  R30
	ST   X,R30
; 0000 03F8             // Calcul de l'angle et conversion pour affichage
; 0000 03F9             AngleEnDegreFoisDix = MSLSBYTEtoUINT(Direction_MSB,Direction_LSB);
	LDD  R30,Y+8
	ST   -Y,R30
	LDD  R30,Y+8
	ST   -Y,R30
	CALL _MSLSBYTEtoUINT
	STD  Y+5,R30
	STD  Y+5+1,R31
; 0000 03FA             itoa(AngleEnDegreFoisDix,AfficheAngle);
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 03FB // --------------------------------------------------------------------------------------------------------------------------
; 0000 03FC             // Affichage du rsultat
; 0000 03FD // --------------------------------------------------------------------------------------------------------------------------
; 0000 03FE             // Ecriture sur le lcd
; 0000 03FF             if ((Direction_MSB_1 != Direction_MSB)||(Direction_LSB_1 != Direction_LSB))
	LDD  R30,Y+8
	LDD  R26,Y+10
	CP   R30,R26
	BRNE _0x12A
	LDD  R30,Y+7
	LDD  R26,Y+9
	CP   R30,R26
	BREQ _0x129
_0x12A:
; 0000 0400                 {	// Affichage des deux octets
; 0000 0401 	                sprintf(Buffer_for_LCD_Line0,"MSB=%-x LSB=%-x",Direction_MSB, Direction_LSB);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,676
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+15
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 0402 	                Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,AfficheAngle); // Affichage de l'angle
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 0403 	                Display_Arrow_0n_I2C_LCDBATRON();
	CALL _Display_Arrow_0n_I2C_LCDBATRON
; 0000 0404 	                Direction_MSB_1 = Direction_MSB; Direction_LSB_1 = Direction_LSB;
	LDD  R30,Y+8
	STD  Y+10,R30
	LDD  R30,Y+7
	STD  Y+9,R30
; 0000 0405                 }
; 0000 0406 
; 0000 0407             delay_ms(100); // pour affichage stable sur le LCD
_0x129:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0408 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0409        		switch (BP_I2C)
	__GETB1SX 238
; 0000 040A 				{
; 0000 040B 					case ECHAP_I2C: Menu = Menu4_HMC6352;  break;       // touche Enter
	CPI  R30,LOW(0x80)
	BRNE _0x12F
	LDI  R30,LOW(3)
	RJMP _0x156
; 0000 040C 					case FlecheH_I2C: Menu = Menu3_SD21;  break;        // touche flche haut
_0x12F:
	CPI  R30,LOW(0x2)
	BRNE _0x130
	LDI  R30,LOW(2)
	RJMP _0x156
; 0000 040D 					case FlecheB_I2C: Menu = Menu1_LED_BP;  break;      // touche flche bas
_0x130:
	CPI  R30,LOW(0x4)
	BRNE _0x132
	LDI  R30,LOW(0)
	RJMP _0x156
; 0000 040E 					default: Menu = Test_HMC6352; ;
_0x132:
	LDI  R30,LOW(17)
_0x156:
	STS  _Menu,R30
; 0000 040F 				}
; 0000 0410 
; 0000 0411 			Menu_1 = Test_HMC6352; ;
	LDI  R30,LOW(17)
	RJMP _0x13D
; 0000 0412        break;
; 0000 0413 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0414 // ==========================================================================================================================
; 0000 0415 // Commande de quatre servos relis  la carte SD21  associ au menu "[3] Test SD21"
; 0000 0416 // ==========================================================================================================================
; 0000 0417         case Test_SD21 : if (Menu_1 != Menu)
_0x128:
	CPI  R30,LOW(0x12)
	BREQ PC+3
	JMP _0x1F
	LDS  R30,_Menu
	LDS  R26,_Menu_1
	CP   R30,R26
	BREQ _0x134
; 0000 0418        		{
; 0000 0419                 sprintf(Buffer_for_LCD_Line0,TexteTestSD21);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_TexteTestSD21
	LDS  R31,_TexteTestSD21+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 041A 				sprintf(Buffer_for_LCD_Line1,Ligne1ChoixEchap5s);
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Ligne1ChoixEchap5s
	LDS  R31,_Ligne1ChoixEchap5s+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 041B 				Displ_2Lines_On_I2C_LCDBATRON(Buffer_for_LCD_Line0,Buffer_for_LCD_Line1);
	MOVW R30,R28
	ADIW R30,33
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	CALL _Displ_2Lines_On_I2C_LCDBATRON
; 0000 041C        		}
; 0000 041D 
; 0000 041E             // Position initial du servo1
; 0000 041F             RegSpeedValue = Vitesse; RegPosLByte= 0xE8; RegPosHByte=0x03;  					// 1000s = 03E8h
_0x134:
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ADIW R30,2
	LDD  R26,Y+15
	STD  Z+0,R26
	LDI  R30,LOW(232)
	__PUTB1SX 263
	LDI  R30,LOW(3)
	__PUTB1SX 264
; 0000 0420             TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));			// Vitesse, LSByte, MSByte
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0421             // ===============================================================================================================
; 0000 0422             // ================================================ Boucle  ======================================================
; 0000 0423             // ===============================================================================================================
; 0000 0424             // Pour info
; 0000 0425             // 1000 = 3E8h	valeur min
; 0000 0426             // 1250 = 4E2h
; 0000 0427             // 1500 = 5DCh
; 0000 0428             // 1750 = 6D6h
; 0000 0429             // 1950 = 7E9h et + ?
; 0000 042A             // ---------------------------------------------------------------------------------------------------------------
; 0000 042B             // Les valeurs "n Servo + Position" transmises  la carte SD21 par le bus I2C doivent tre places dans
; 0000 042C             // les tableaux situs dans le fichier "TableRob.h"
; 0000 042D             // Le nom des servos est dclar dans le fichier sd21.h
; 0000 042E             // ---------------------------------------------------------------------------------------------------------------
; 0000 042F 
; 0000 0430             while (BP_I2C != ECHAP_I2C) // Test des servos tant que l'on n'appuie pas sur "ECHAP"
_0x135:
	__GETB2SX 238
	CPI  R26,LOW(0x80)
	BRNE PC+3
	JMP _0x137
; 0000 0431             {
; 0000 0432                 // Configuration des paramtres "Servox" [0<x<5] et "position" envoys aux servos
; 0000 0433                 for(i=0; i<sizeof(Tab_Servo); i++)
	LDI  R30,LOW(0)
	STD  Y+11,R30
	STD  Y+11+1,R30
_0x139:
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	SBIW R26,4
	BRLO PC+3
	JMP _0x13A
; 0000 0434                 {
; 0000 0435                 // Configuration de la trame "Frame_I2C_Servo" avec les valeurs contenues dans les tableaux situs dans
; 0000 0436                 // le fichier TableRob.h
; 0000 0437                 NumServo = Tab_Servo[i]; RegPosLByte = LSBYTE(Tab_Position[i]);  RegPosHByte = MSBYTE(Tab_Position[i]);
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ADIW R30,1
	MOVW R26,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	SUBI R30,LOW(-_Tab_Servo*2)
	SBCI R31,HIGH(-_Tab_Servo*2)
	LPM  R30,Z
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ADIW R30,3
	PUSH R31
	PUSH R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	LDI  R26,LOW(_Tab_Position*2)
	LDI  R27,HIGH(_Tab_Position*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	ST   -Y,R31
	ST   -Y,R30
	CALL _LSBYTE
	POP  R26
	POP  R27
	ST   X,R30
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ADIW R30,4
	PUSH R31
	PUSH R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	LDI  R26,LOW(_Tab_Position*2)
	LDI  R27,HIGH(_Tab_Position*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	ST   -Y,R31
	ST   -Y,R30
	CALL _MSBYTE
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0438 
; 0000 0439 	            // Envoi de la trame  "Frame_I2C_Servo"  la carte SD21
; 0000 043A 	            TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 043B 
; 0000 043C 	            // Visualisation de la position des valeurs places dans les tableaux sur les Led de la carte Sisi
; 0000 043D 	            Frame_I2C_LED_Switching[1] = ~(i+1);
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ADIW R30,1
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,-LOW(1)
	COM  R30
	ST   X,R30
; 0000 043E 	            TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 043F 	            delay_ms(tempo);
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0440                 } // fin du for
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ADIW R30,1
	STD  Y+11,R30
	STD  Y+11+1,R31
	RJMP _0x139
_0x13A:
; 0000 0441 
; 0000 0442                 BP_I2C = Lire_BP_I2C();
	CALL _Lire_BP_I2C
	__PUTB1SX 238
; 0000 0443             }
	RJMP _0x135
_0x137:
; 0000 0444             // Servo maintenus dans leur dernire position
; 0000 0445             RegSpeedValue = 0; TWI_Start_Transc_With_Data(Frame_I2C_Servo,sizeof(Frame_I2C_Servo));
	LDI  R30,LOW(0)
	__PUTB1SX 262
	MOVW R30,R28
	SUBI R30,LOW(-(260))
	SBCI R31,HIGH(-(260))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0446 
; 0000 0447 			Menu = Menu3_SD21 ; Menu_1 = Test_SD21 ;
	LDI  R30,LOW(2)
	STS  _Menu,R30
	LDI  R30,LOW(18)
_0x13D:
	STS  _Menu_1,R30
; 0000 0448 
; 0000 0449        break;
; 0000 044A // ==========================================================================================================================
; 0000 044B     }// Fin du switch1
_0x1F:
; 0000 044C 
; 0000 044D     Frame_I2C_LED_Switching[1] = ~Frame_I2C_BP_Read[1]; // Inversion de l'tat logique des BP pour affichage sur les leds
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ADIW R30,1
	MOVW R26,R30
	__GETB1SX 302
	COM  R30
	ST   X,R30
; 0000 044E // --------------------------------------------------------------------------------------------------------------------------
; 0000 044F // ----------------------------------------  Champ Ecriture des rsultats  --------------------------------------------------
; 0000 0450 // Ecriture sur les LED
; 0000 0451     TWI_Start_Transc_With_Data(Frame_I2C_LED_Switching,sizeof(Frame_I2C_LED_Switching));  // Les LED affichent l'tat des BP
	MOVW R30,R28
	SUBI R30,LOW(-(303))
	SBCI R31,HIGH(-(303))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _TWI_Start_Transc_With_Data
; 0000 0452 // --------------------------------------------------------------------------------------------------------------------------
; 0000 0453 //delay_ms(100);   // A utiliser pour visualiser les trames I2C
; 0000 0454   }; // Fin while(1)
	JMP  _0x19
; 0000 0455 
; 0000 0456 } //Fin main
_0x13B:
	RJMP _0x13B

	.DSEG
_0x110:
	.BYTE 0x1C
;// ==========================================================================================================================
;// ==========================================================================================================================
;
;

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(45)
	ST   X,R30
_0x2000003:
_0x2000005:
	__GETD1S 2
	__GETD2S 8
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2000008
	CPI  R16,0
	BRNE _0x2000008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2000007
_0x2000008:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2000007:
	__GETD1S 2
	__GETD2S 8
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	CALL __DIVD21U
	__PUTD1S 2
	CALL __CPD10
	BREQ _0x2000006
	RJMP _0x2000005
_0x2000006:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	JMP  _0x2120003

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G101:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020012
	__CPWRN 16,17,2
	BRLO _0x2020013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2020014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2020014:
_0x2020013:
	RJMP _0x2020015
_0x2020010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2020015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	JMP  _0x2120004
__print_G101:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2020016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2020018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x202001C
	CPI  R18,37
	BRNE _0x202001D
	LDI  R17,LOW(1)
	RJMP _0x202001E
_0x202001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x202001E:
	RJMP _0x202001B
_0x202001C:
	CPI  R30,LOW(0x1)
	BRNE _0x202001F
	CPI  R18,37
	BRNE _0x2020020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20200C9
_0x2020020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020021
	LDI  R16,LOW(1)
	RJMP _0x202001B
_0x2020021:
	CPI  R18,43
	BRNE _0x2020022
	LDI  R20,LOW(43)
	RJMP _0x202001B
_0x2020022:
	CPI  R18,32
	BRNE _0x2020023
	LDI  R20,LOW(32)
	RJMP _0x202001B
_0x2020023:
	RJMP _0x2020024
_0x202001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2020025
_0x2020024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2020026
	ORI  R16,LOW(128)
	RJMP _0x202001B
_0x2020026:
	RJMP _0x2020027
_0x2020025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x202001B
_0x2020027:
	CPI  R18,48
	BRLO _0x202002A
	CPI  R18,58
	BRLO _0x202002B
_0x202002A:
	RJMP _0x2020029
_0x202002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x202001B
_0x2020029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x202002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2020030
_0x202002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2020032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2020033
_0x2020032:
	CPI  R30,LOW(0x70)
	BRNE _0x2020035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x64)
	BREQ _0x2020039
	CPI  R30,LOW(0x69)
	BRNE _0x202003A
_0x2020039:
	ORI  R16,LOW(4)
	RJMP _0x202003B
_0x202003A:
	CPI  R30,LOW(0x75)
	BRNE _0x202003C
_0x202003B:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x202003D
_0x202003C:
	CPI  R30,LOW(0x58)
	BRNE _0x202003F
	ORI  R16,LOW(8)
	RJMP _0x2020040
_0x202003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2020071
_0x2020040:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x202003D:
	SBRS R16,2
	RJMP _0x2020042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020043:
	CPI  R20,0
	BREQ _0x2020044
	SUBI R17,-LOW(1)
	RJMP _0x2020045
_0x2020044:
	ANDI R16,LOW(251)
_0x2020045:
	RJMP _0x2020046
_0x2020042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2020046:
_0x2020036:
	SBRC R16,0
	RJMP _0x2020047
_0x2020048:
	CP   R17,R21
	BRSH _0x202004A
	SBRS R16,7
	RJMP _0x202004B
	SBRS R16,2
	RJMP _0x202004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x202004D
_0x202004C:
	LDI  R18,LOW(48)
_0x202004D:
	RJMP _0x202004E
_0x202004B:
	LDI  R18,LOW(32)
_0x202004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2020048
_0x202004A:
_0x2020047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x202004F
_0x2020050:
	CPI  R19,0
	BREQ _0x2020052
	SBRS R16,3
	RJMP _0x2020053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2020054
_0x2020053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2020054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2020055
	SUBI R21,LOW(1)
_0x2020055:
	SUBI R19,LOW(1)
	RJMP _0x2020050
_0x2020052:
	RJMP _0x2020056
_0x202004F:
_0x2020058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x202005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x202005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x202005A
_0x202005C:
	CPI  R18,58
	BRLO _0x202005D
	SBRS R16,3
	RJMP _0x202005E
	SUBI R18,-LOW(7)
	RJMP _0x202005F
_0x202005E:
	SUBI R18,-LOW(39)
_0x202005F:
_0x202005D:
	SBRC R16,4
	RJMP _0x2020061
	CPI  R18,49
	BRSH _0x2020063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020062
_0x2020063:
	RJMP _0x20200CA
_0x2020062:
	CP   R21,R19
	BRLO _0x2020067
	SBRS R16,0
	RJMP _0x2020068
_0x2020067:
	RJMP _0x2020066
_0x2020068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2020069
	LDI  R18,LOW(48)
_0x20200CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x202006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006B
	SUBI R21,LOW(1)
_0x202006B:
_0x202006A:
_0x2020069:
_0x2020061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x202006C
	SUBI R21,LOW(1)
_0x202006C:
_0x2020066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2020059
	RJMP _0x2020058
_0x2020059:
_0x2020056:
	SBRS R16,0
	RJMP _0x202006D
_0x202006E:
	CPI  R21,0
	BREQ _0x2020070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x202006E
_0x2020070:
_0x202006D:
_0x2020071:
_0x2020030:
_0x20200C9:
	LDI  R17,LOW(0)
_0x202001B:
	RJMP _0x2020016
_0x2020018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2020072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2120005
_0x2020072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2120005:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG

	.CSEG
_strcat:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcat0:
    ld   r22,x+
    tst  r22
    brne strcat0
    sbiw r26,1
strcat1:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcat1
    movw r30,r24
    ret
_strcpy:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpy0:
    ld   r22,z+
    st   x+,r22
    tst  r22
    brne strcpy0
    movw r30,r24
    ret
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_TWI_Master_Initialise:
	LDI  R30,LOW(32)
	OUT  0x0,R30
	LDI  R30,LOW(255)
	OUT  0x3,R30
	LDI  R30,LOW(4)
	OUT  0x36,R30
	RET
_TWI_Transceiver_Busy:
	IN   R30,0x36
	ANDI R30,LOW(0x1)
	RET
_TWI_Start_Transc_With_Data:
	ST   -Y,R17
_0x2080007:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080007
	LDD  R30,Y+1
	STS  _TWI_msgSize_G104,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	STS  _TWI_buf_G104,R30
	ANDI R30,LOW(0x1)
	BRNE _0x208000A
	LDI  R17,LOW(1)
_0x208000C:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x208000D
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R0,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R0
	ST   X,R30
	SUBI R17,-1
	RJMP _0x208000C
_0x208000D:
_0x208000A:
	LDI  R30,LOW(0)
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(248)
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(165)
	OUT  0x36,R30
	LDD  R17,Y+0
	RJMP _0x2120002
_TWI_Get_Data_From_Transceiver:
	ST   -Y,R17
_0x2080011:
	RCALL _TWI_Transceiver_Busy
	CPI  R30,0
	BRNE _0x2080011
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	BREQ _0x2080014
	LDI  R17,LOW(0)
_0x2080016:
	LDD  R30,Y+1
	CP   R17,R30
	BRSH _0x2080017
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x2080016
_0x2080017:
_0x2080014:
	LDS  R30,_TWI_statusReg
	ANDI R30,LOW(0x1)
	LDD  R17,Y+0
	RJMP _0x2120002
_twi_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	IN   R30,0x1
	CPI  R30,LOW(0x8)
	BREQ _0x208001C
	CPI  R30,LOW(0x10)
	BRNE _0x208001D
_0x208001C:
	LDI  R30,LOW(0)
	STS  _TWI_bufPtr_S1040006000,R30
	RJMP _0x208001E
_0x208001D:
	CPI  R30,LOW(0x18)
	BRNE _0x208001F
_0x208001E:
	RJMP _0x2080020
_0x208001F:
	CPI  R30,LOW(0x28)
	BRNE _0x2080021
_0x2080020:
	LDS  R30,_TWI_msgSize_G104
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080022
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	LD   R30,Z
	OUT  0x3,R30
	LDI  R30,LOW(133)
	RJMP _0x2080033
_0x2080022:
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
_0x2080033:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080021:
	CPI  R30,LOW(0x50)
	BRNE _0x2080024
	LDS  R30,_TWI_bufPtr_S1040006000
	SUBI R30,-LOW(1)
	STS  _TWI_bufPtr_S1040006000,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_TWI_buf_G104)
	SBCI R31,HIGH(-_TWI_buf_G104)
	MOVW R26,R30
	IN   R30,0x3
	ST   X,R30
	RJMP _0x2080025
_0x2080024:
	CPI  R30,LOW(0x40)
	BRNE _0x2080026
_0x2080025:
	LDS  R30,_TWI_msgSize_G104
	SUBI R30,LOW(1)
	LDS  R26,_TWI_bufPtr_S1040006000
	CP   R26,R30
	BRSH _0x2080027
	LDI  R30,LOW(197)
	RJMP _0x2080034
_0x2080027:
	LDI  R30,LOW(133)
_0x2080034:
	OUT  0x36,R30
	RJMP _0x208001A
_0x2080026:
	CPI  R30,LOW(0x58)
	BRNE _0x2080029
	LDS  R26,_TWI_bufPtr_S1040006000
	LDI  R27,0
	SUBI R26,LOW(-_TWI_buf_G104)
	SBCI R27,HIGH(-_TWI_buf_G104)
	IN   R30,0x3
	ST   X,R30
	LDS  R30,_TWI_statusReg
	ORI  R30,1
	STS  _TWI_statusReg,R30
	LDI  R30,LOW(148)
	RJMP _0x2080035
_0x2080029:
	CPI  R30,LOW(0x38)
	BRNE _0x208002A
	LDI  R30,LOW(165)
	RJMP _0x2080035
_0x208002A:
_0x208002C:
	IN   R30,0x1
	STS  _TWI_state_G104,R30
	LDI  R30,LOW(4)
_0x2080035:
	OUT  0x36,R30
_0x208001A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI

	.CSEG
_LSBYTE:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	MOV  R16,R30
	CLR  R17
	MOV  R30,R16
	RJMP _0x2120001
_MSBYTE:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ANDI R30,LOW(0xFF00)
	MOV  R30,R31
	LDI  R31,0
	MOV  R16,R30
	CLR  R17
	MOV  R30,R16
	RJMP _0x2120001
_MSLSBYTEtoUINT:
	ST   -Y,R17
	ST   -Y,R16
	__GETWRN 16,17,0
	LDD  R16,Y+3
	CLR  R17
	MOV  R27,R16
	LDI  R26,LOW(0)
	LDD  R30,Y+2
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R16,R30
	MOVW R30,R16
	RJMP _0x2120001

	.CSEG
_Init_LCD_I2C_BATRON:
	SBIW R28,13
	LDI  R24,13
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20C0003*2)
	LDI  R31,HIGH(_0x20C0003*2)
	CALL __INITLOCB
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,13
	RET
_LCD_I2C_BATRON_gotoxy:
	SBIW R28,3
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDD  R26,Y+4
	CPI  R26,LOW(0x10)
	BRSH _0x20C0005
	LDD  R26,Y+3
	CPI  R26,LOW(0x2)
	BRLO _0x20C0006
_0x20C0005:
	RJMP _0x20C0004
_0x20C0006:
	LDD  R30,Y+3
	CPI  R30,0
	BRNE _0x20C000A
	LDD  R30,Y+4
	SUBI R30,-LOW(128)
	RJMP _0x20C0017
_0x20C000A:
	CPI  R30,LOW(0x1)
	BRNE _0x20C0009
	LDD  R30,Y+4
	SUBI R30,-LOW(192)
_0x20C0017:
	STD  Y+2,R30
_0x20C0009:
_0x20C0004:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
_0x2120004:
	ADIW R28,5
	RET
_Built_Strng_Fram_I2C_LCDBATRON:
	CALL __SAVELOCR6
	__GETWRS 18,19,8
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,2
	MOVW R20,R30
	__GETWRN 16,17,0
_0x20C000D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R16,R30
	CPC  R17,R31
	BRGE _0x20C000E
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5B)
	BRNE _0x20C000F
	MOVW R26,R20
	LDI  R30,LOW(138)
	RJMP _0x20C0018
_0x20C000F:
	MOVW R26,R18
	LD   R26,X
	CPI  R26,LOW(0x5D)
	BRNE _0x20C0011
	MOVW R26,R20
	LDI  R30,LOW(84)
	RJMP _0x20C0018
_0x20C0011:
	MOVW R26,R18
	LD   R30,X
	SUBI R30,-LOW(128)
	MOVW R26,R20
_0x20C0018:
	ST   X,R30
	__ADDWRN 18,19,1
	__ADDWRN 20,21,1
	__ADDWRN 16,17,1
	RJMP _0x20C000D
_0x20C000E:
	MOVW R26,R20
	LDI  R30,LOW(0)
	ST   X,R30
	CALL __LOADLOCR6
_0x2120003:
	ADIW R28,12
	RET
_Displ_2Lines_On_I2C_LCDBATRON:
	SBIW R28,19
	LDI  R24,19
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x20C0013*2)
	LDI  R31,HIGH(_0x20C0013*2)
	CALL __INITLOCB
	ST   -Y,R17
	LDI  R17,LOW(0)
_0x20C0015:
	CPI  R17,2
	BRSH _0x20C0016
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	SUBI R17,-1
	RJMP _0x20C0015
_0x20C0016:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Built_Strng_Fram_I2C_LCDBATRON
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDD  R17,Y+0
	ADIW R28,24
	RET
_Display_Arrow_0n_I2C_LCDBATRON:
	SBIW R28,6
	LDI  R30,LOW(118)
	ST   Y,R30
	LDI  R30,LOW(64)
	STD  Y+1,R30
	LDI  R30,LOW(48)
	STD  Y+2,R30
	LDI  R30,LOW(118)
	STD  Y+3,R30
	LDI  R30,LOW(64)
	STD  Y+4,R30
	LDI  R30,LOW(18)
	STD  Y+5,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _LCD_I2C_BATRON_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	ADIW R28,6
	RET

	.CSEG
_Lire_BP_I2C:

	.DSEG

	.CSEG
	SBIW R28,2
	LDI  R30,LOW(67)
	ST   Y,R30
	LDI  R30,LOW(0)
	STD  Y+1,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	LDS  R30,_Etat_BP_I2C_S1070000000
	CPI  R30,0
	BRNE _0x20E0007
	CPI  R16,0
	BRNE _0x20E0008
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20E0009
	LDI  R30,LOW(1)
	STS  _Etat_BP_I2C_S1070000000,R30
	LDI  R30,LOW(0)
	RJMP _0x2120001
_0x20E0009:
	LDI  R30,LOW(255)
	RJMP _0x2120001
_0x20E0008:
	LDI  R30,LOW(255)
	RJMP _0x2120001
_0x20E0007:
	CPI  R30,LOW(0x1)
	BRNE _0x20E0006
	CPI  R16,0
	BREQ _0x20E000D
	MOV  R17,R16
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Start_Transc_With_Data
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _TWI_Get_Data_From_Transceiver
	LDD  R16,Y+3
	CP   R16,R17
	BRNE _0x20E000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1070000000,R30
	MOV  R30,R16
	RJMP _0x2120001
_0x20E000E:
	LDI  R30,LOW(0)
	RJMP _0x2120001
_0x20E000D:
	LDI  R30,LOW(0)
_0x20E0006:
_0x2120001:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x2120002:
	ADIW R28,4
	RET

	.CSEG

	.DSEG
_TexteMenuHMC6352:
	.BYTE 0x2
_Ligne0MenuMode:
	.BYTE 0x2
_Ligne0MenuInfos:
	.BYTE 0x2
_Ligne0MenuDeplacements:
	.BYTE 0x2
_TexteTestSD21:
	.BYTE 0x2
_TexteTest1BpsurLed:
	.BYTE 0x2
_Ligne1PlusMoins:
	.BYTE 0x2
_Ligne1ChoixEntr:
	.BYTE 0x2
_Ligne1ChoixEchap:
	.BYTE 0x2
_Ligne1ChoixEchap5s:
	.BYTE 0x2
_Ligne1ChoixEchapOk:
	.BYTE 0x2
_Ligne1ChoixEchapSET:
	.BYTE 0x2
_BpPlusSurD0:
	.BYTE 0x2
_BpFlecheHSurD1:
	.BYTE 0x2
_BpFlecheHSurD2:
	.BYTE 0x2
_BpMoinsSurD3:
	.BYTE 0x2
_BpSetSurD4:
	.BYTE 0x2
_BpOkSurD5:
	.BYTE 0x2
_BpEntrSurD6:
	.BYTE 0x2
_BpEchSurD7:
	.BYTE 0x2
_Menu:
	.BYTE 0x1
_Menu_1:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4
_TWI_msgSize_G104:
	.BYTE 0x1
_TWI_buf_G104:
	.BYTE 0x14
_TWI_state_G104:
	.BYTE 0x1
_TWI_statusReg:
	.BYTE 0x1
_TWI_bufPtr_S1040006000:
	.BYTE 0x1
_Etat_BP_I2C_S1070000000:
	.BYTE 0x1

	.CSEG

	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
	CLR  R25
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
